/******************************************************************
 *	waveChart.h: ȷϢʥѥ֥åإåե
 *
 *				Programed by Nobuyuki Maruichi
 *				Adviced by S.Kouno
 *
 *	Note.
 *			SHIFT JIS Kanji Code / JIS X0208 1983
 *			Tab Size 4 / Shift Width = 4
 *
 *
 *
 ******************************************************************/

#ifndef _XawWaveChart_h
#define _XawWaveChart_h

#ifdef	USE_Xaw3d
# include <X11/Xaw3d/Simple.h>
#endif	/*USE_Xaw3d*/
#ifdef	USE_neXtaw
# include <X11/neXtaw/Simple.h>
#endif	/*USE_neXtaw*/
#ifdef	USE_Xaw95
# include <X11/Xaw95/Simple.h>
#endif	/*USE_Xaw95*/
#if !(defined(USE_Xaw3d) || defined(USE_Xaw95) || defined(USE_neXtaw))
# include <X11/Xaw/Simple.h>
#endif /* !(defined(USE_Xaw3d) || defined(USE_Xaw95) || defined(USE_neXtaw)) */

/***********************************************************************
 *
 * WaveChart Widget
 *
 ***********************************************************************/

/* WaveChart resources:

 Name			     Class				RepType			Default Value
 ----			     -----				-------			-------------
 accelerators	     Accelerators		AcceleratorTable NULL
 ancestorSensitive   AncestorSensitive	Boolean			True 
 background		     Background			Pixel			XtDefaultBackground
 backgroundPixmap    Pixmap				Pixmap			XtUnspecifiedPixmap
 borderColor	     BorderColor		Pixel			XtDefaultForeground
 borderPixmap	     Pixmap				Pixmap			XtUnspecifiedPixmap
 borderWidth	     BorderWidth		Dimension		1
 colormap		     Colormap			Colormap		parent's colormap
 cursor			     Cursor				Cursor			None
 cursorName		     Cursor				String			NULL
 depth			     Depth				int				parent's depth
 destroyCallback     Callback			XtCallbackList	NULL
 foreground		     Foreground			Pixel			XtDefaultForeground
 getValue		     Callback			XtCallbackList	NULL
 height			     Height				Dimension		120
 highlight		     Foreground			Pixel			XtDefaultForeground
 insensitiveBorder   Insensitive		Pixmap			GreyPixmap
 jumpScroll		     JumpScroll			int				1/2 width
 mappedWhenManaged   MappedWhenManaged	Boolean			True
 minScale		     Scale				int				1
 pointerColor	     Foreground			Pixel			XtDefaultForeground
 pointerColorBackground Background		Pixel			XtDefaultBackground
 screen			     Screen				Screen			parent's screen
 sensitive		     Sensitive			Boolean			True
 translations	     Translations		TranslationTable NULL
 width			     Width				Dimension		120
 x				     Position			Position		0
 y				     Position			Position		0
ɲå꥽
 topLimit			 YCoordinate		int				1
 bottomLimit		 YCoordinate		int				-1
 leftLimit			 XCoordinate		int				0
 rightLimit			 XCoordinate		int				100
*/

#define DEFAULT_JUMP -1

#ifndef _XtStringDefs_h_
#define XtNhighlight "highlight"
#endif

#define XtCScale "Scale"
#define XtCXCoordinate	"XCoordinate"
#define XtCYCoordinate	"YCoordinate"
#define XtCCaretFlag	"CaretFlag"

#define XtNminScale "minScale"
#define XtNscale "scale"

#define XtNtopLimit "topLimit"
#define XtNbottomLimit "bottomLimit"
#define XtNleftLimit "leftLimit"
#define XtNrightLimit "rightLimit"

#define XtNselectConvert	"selectConvert"
#define XtNselectPaste		"selectPaste"
#define XtNselectCut		"selectCut"
#define XtNcaretPixel		"caretPixel"
#define XtNcaretFlag		"caretFlag"

#define WAVE_PROPERTY_NAME	"PCM8TOWNS"

typedef struct _WaveChartRec *WaveChartWidget;
typedef struct _WaveChartClassRec *WaveChartWidgetClass;

/***********************************************************************
 *	XawRepaintWave ѹ¤
 *		ǡɸϡ		ȷǡȰабɸ
 *		պɸϡ		ɽбۥå
 *							Ȥɸ
 *		åȺɸϡåȤθбɸ
 *	
 ***********************************************************************/
typedef struct _XawRepaintWave {
	double *wave;				/* Ѥοͥǡ */
	unsigned long size;			/* ǡ */
	unsigned long virtualWidth;	/* ۥåʥ */
	unsigned long exposeX;		/* 賫ϣغɸ */
	unsigned long exposeWidth;	/*  */
	unsigned long graphBegin;	/* դγϣغɸʥǡɸ */
	unsigned long graphWidth;	/* դʥǡɸ */
	unsigned long dataBegin;	/* ǡγϣغɸʥǡɸ */
	unsigned long dataWidth;	/* ǡʥǡɸ */
} XawRepaintWave;

typedef struct _XawWaveSelectionConvert {
	Boolean status;					/* ؿ֤ */
	Atom *type_return;				/* ѴΥץѥƥ֤ */
	XtPointer *value_return;		/* 쥯ͤγǼ򼨤 */
	unsigned long *length_return;	/* 쥯ͤǤθĿ */
	int *format_return;				/* 쥯ͤǤ礭 */
	int selectStart;				/* 쥯ϰϤγϰ֤򼨤 */
	int selectEnd;					/* 쥯ϰϤνλ֤򼨤 */
} XawWaveSelectionConvert;

typedef struct _XawWaveSelectionPaste {
	XtPointer client_data;
	Atom *selection;				/* ׵ᤷƤ쥯 */
	Atom *type;						/* 쥯ͤɽ򼨤ޤ */
	XtPointer value;				/* 쥯ͤγǼ򼨤 */
	unsigned long length;			/* 쥯ͤǤθĿ */
	int format;						/* 쥯ͤǤ礭 */
	int pastePos;					/* ڡȰ֤򼨤 */
} XawWaveSelectionPaste;

typedef struct _XawWaveSelectionArea {
	int selectStart;				/* 쥯ϰϤγϰ֤򼨤 */
	int selectEnd;					/* 쥯ϰϤνλ֤򼨤 */
} XawWaveSelectionArea ;

extern WidgetClass waveChartWidgetClass;

void WaveRedrawCall(Widget w);
void MakeWaveGraph(Widget w, const double *wave, int size, 
				int dataBegin, int dataEnd, int graphBegin, int graphEnd);
Boolean SelectArea(Widget w, size_t *selectStart, size_t *selectEnd);
Boolean XawIsWaveChartSelecting(Widget w);
void XawWaveAllClear(Widget w);
void XawWaveSelectionInit(Widget w);

#endif /* _XawWaveChart_h */
/* DON'T ADD STUFF AFTER THIS #endif */
 
