/***********************************************************************
 *	waveChartP.h: ȷϢʥץ饤١ȥإåե
 *
 *				Programed by Nobuyuki Maruichi
 *				Adviced by S.Kouno
 *
 *	Note.
 *			SHIFT JIS Kanji Code / JIS X0208 1983
 *			Tab Size 4 / Shift Width = 4
 *
 ***********************************************************************/

#ifndef _XawWaveChartP_h
#define _XawWaveChartP_h

#include "WaveChart.h"
#ifdef	USE_Xaw3d
# include <X11/Xaw3d/SimpleP.h>
#endif	/*USE_Xaw3d*/
#ifdef	USE_neXtaw
# include <X11/neXtaw/SimpleP.h>
#endif	/*USE_neXtaw*/
#ifdef	USE_Xaw95
# include <X11/Xaw95/SimpleP.h>
#endif	/*USE_Xaw95*/
#if !(defined(USE_Xaw3d) || defined(USE_Xaw95) || defined(USE_neXtaw))
# include <X11/Xaw/SimpleP.h>
#endif /* !(defined(USE_Xaw3d) || defined(USE_Xaw95) || defined(USE_neXtaw)) */

#define NO_GCS 0
#define FOREGROUND	1 << 0
#define BACKGROUND	1 << 1
#define HIGHLIGHT	1 << 2
#define CARET		1 << 3
#define PFOREGROUND	1 << 4
#define PBACKGROUND	1 << 5
#define ALL_GCS \
	(PBACKGROUND | PFOREGROUND | BACKGROUND | FOREGROUND | HIGHLIGHT | CARET)

/* New fields for the waveChart widget instance record */

typedef struct {
	Pixel	fgpixel;	/* color index for graph */
	Pixel	hipixel;	/* color index for lines */
	Pixel	caretPixel;	/* color index for caret */
	GC	fgGC;			/* graphics context for fgpixel */
	GC	bgGC;			/* graphics context for inverse */
	GC	hiGC;			/* graphics context for hipixel */
	GC	caretGC;		/* graphics context for caretPixel */

	/* start of graph stuff */

	int	scale;			/* scale factor */
	int	min_scale;		/* smallest scale factor */
	XPoint * points ;	/* Poly point for repairing graph lines. */
	double max_value;	/* Max Value in window */
	int jump_val;		/* Amount to jump on each scroll. */
	Pixmap graph_pixmap;
	GC gp_norm_gc;
	GC gp_inv_gc;
	Atom target_atom;
	int topLimit;
	int bottomLimit;
	int leftLimit;
	int rightLimit;
	int caret;
	int selectBase;
	int selectStart;
	int selectEnd;
	int selectStartInner;
	int selectEndInner;
	Boolean selection;
	Boolean caretFlag;
	XtCallbackList callbacks;
	XtCallbackList selectConvert;
	XtCallbackList selectCut;
	XtCallbackList selectPaste;
} WaveChartPart;

/* Full instance record declaration */
typedef struct _WaveChartRec {
	CorePart core;
	SimplePart simple;
#ifdef _ThreeDP_h
	ThreeDClassPart		threeD_class;
#endif /*_ThreeDP_h*/
	WaveChartPart wave_chart;
} WaveChartRec;

/* New fields for the WaveChart widget class record */
typedef struct {int dummy;} WaveChartClassPart;

/* Full class record declaration. */
typedef struct _WaveChartClassRec {
	CoreClassPart core_class;
	SimpleClassPart simple_class;
#ifdef _ThreeDP_h
	ThreeDPart	threeD;
#endif /*_ThreeDP_h*/
	WaveChartClassPart wave_chart_class;
} WaveChartClassRec;

/* Class pointer. */
extern WaveChartClassRec waveChartClassRec;

#endif /* _XawWaveChartP_h */
 
