/****************************************************************************
 *	ggxsnd: g^2xsnd is not gxsnd (It's joke !!)
 *		g squared X sound
 *
 *			Date. 1994/08/13 -- 1995/10/22
 *			Date. 1998/05/14 -- 1998/05/15 (Debian GNU/Linux support.)
 *				Programed by Nobuyuki Maruichi
 *				Adviced by S.Kouno
 *
 *	from
 *		PCM player T-E-S-T program  Copyright (C) 1993 S.Kouno
 *		PCM recording T-E-S-T program  Copyright (C) 1993 S.Kouno
 ****************************************************************************/

#ifndef _GGXSND_H
#define _GGXSND_H

#include "snd.h"
#include "xfile.h"

# define VERSION_NO		"0.8.0"
# define GGXSND_VERSION	"Version 0.8.0"

/****************************************************************************
 *	WaveOrder: ȷѡ֥롦󥯥ȡꥹȷʻȹ¤
 *	С
 *		size_t encoding_size;			Ѵ줿ʬΥ
 *		size_t recording_size;			Ͽ줿ʬΥ
 *		size_t wave_size;				ȷХåեΥ
 *		char *pcm_wave;					ѥ륹
 *		struct _wave_order *prev_ptr;	Υؤ󥯥ݥ
 *		struct _wave_order *next_ptr;	Υؤ󥯥ݥ
 *	
 *	
 *	WaveOrder: ֥롦󥯥ȡꥹȷʻȹ¤Τι¤
 *	
 *	Ƭ
 *	
 *	ȷΥ
 *	
 *	Уãȷ󨭨ȷΥ
 *	
 *	ؤΥ󥯡Уãȷ󨭨ȷΥ
 *	
 *	ؤΥ󥯨ؤΥ󥯡Уãȷ
 *	
 *	 NULL ݥ󥿡ؤΥ󥯨ؤΥ󥯡
 *	
 *	ؤΥ󥯨
 *	 NULL ݥ󥿨
 *	
 ***************************************************************************/
typedef struct _wave_order {
	size_t encoding_size;
	size_t recording_size;
	size_t wave_size;
	char *pcm_wave;
	struct _wave_order *prev_ptr;
	struct _wave_order *next_ptr;
} WaveOrder;

/****************************************************************************
 *	WaveSearch: ȷѡ֥롦󥯥ȡꥹȷʻȹ¤
 *	С
 *		WaveOrder *wave_ptr;	
 *		size_t offset;			
 *	
 *	
 *	WaveOrder: ֥롦󥯥ȡꥹȷʻȹ¤Τι¤
 *	
 ***************************************************************************/
typedef struct _wave_search {
	WaveOrder *wave_ptr;	
	size_t offset;			
} WaveSearch;

/****************************************************************************
 *	WavesLink: ȷѡ֥롦󥯥ȡꥹȷʻȹ¤
 *	С
 *	
 *		char *wave_name;				ȷ̾Τʤ
 *		WaveOrder *wave;				ȷǡ
 *		struct snd_head header;			SND եΥإå
 *		struct _WavesLink *prev_ptr;	ȷ
 *		struct _WavesLink *next_ptr;	ȷ
 *
 *	WavesLink: ֥롦󥯥ȡꥹȷʻȹ¤Τι¤
 *	
 *	Ƭ
 *	
 *	ȷ̾Τʤɨ
 *	
 *	Уãȷ󨭨ȷΥ
 *	
 *	إå󨭨Уãȷ󨭨ȷΥ
 *	
 *	ؤΥ󥯡إå󨭨Уãȷ
 *	
 *	ؤΥ󥯨ؤΥ󥯡إå
 *	
 *	 NULL ݥ󥿡ؤΥ󥯨ؤΥ󥯡
 *	
 *	ؤΥ󥯨
 *	 NULL ݥ󥿨
 *	
 ***************************************************************************/
typedef struct _WavesLink {
	char *wave_name;
	WaveOrder *wave;
	size_t currentPos;
	struct snd_head header;
	struct _WavesLink *prev_ptr;
	struct _WavesLink *next_ptr;
} WavesLink;

/***************************************************************************
 *	PopdownInfo : ݥåץѤξ
 *	С
 *		popupWidget:	ݥåץåפå
 *		popdownShell:	ݥåץ󤵤륷륦å
 *		client_data:	
 ***************************************************************************/
typedef struct _popdownInfo {
	Widget popupWidget;
	Widget popdownShell;
	XtPointer *client_data;
} PopdownInfo;

/***************************************************************************
 *	oprationCommand : 
 *	
 *		opStop:		
 *		opPause:	ݡ
 *		opPlay:		
 *		opLoad:		
 *		opSave:		
 ***************************************************************************/
typedef enum _oprationCommand {
	opStop, opPause, opRecord, opPlay, opLoad, opSave
} oprationCommand;

/***************************************************************************
 *	operationControl : ڥ졼
 *	С
 *		command_type:		ޥɷ
 *		current_size:		У̣٤ǤΤ߻ѡʺХȿ
 *		current_offset:		У̣٤ǤΤ߻ѡʺϰ֡
 *		current_wave:		У̣٤ǤΤ߻ѡ̤
 *		waveOperationStart:	
 *		wave:				Ȥΰ
 *		stream:				ϤԤեݥ
 *		id:					XtAppAddInput() Σɣ
 *		startOperation:		ϡƳؿʣΣգ̣̤ʤ̵
 *		finishedOperation:	λؿ
 ***************************************************************************/
typedef struct _operationControl {
	oprationCommand command_type;
	size_t playing_size;
	size_t current_size;
	WaveOrder *current_wave;
	WaveOrder *waveOperationStart;
	WavesLink *wave;
	FILE *stream;
	XtInputId id;
	void (*startOperation)(Widget w);
	Boolean (*finishedOperation)(XtPointer client_data);
} operationControl;

/***************************************************************************
 *	ioType: CD-DA  I/O μ̤򼨤
 *		TownsIO: Towns  ioctl
 *		GENERAL_IO: PC/AT  ioctl
 *		
 ***************************************************************************/
typedef enum {
	pcm8towns = 0,
	pcm16towns = 1, 
	unknown
} ioType;

/***************************************************************************
 *	˥塼: ˥塼ܾ
 *	̻
 *		TypeSme:		˥塼ȥδܥ饹
 *		TypeSmeBSB:		Ūʥ˥塼ȥ
 *		TypeSmeLine:	˥塼ܤΥѥ졼
 ***************************************************************************/
enum _MenuType {TypeSme, TypeSmeBSB, TypeSmeLine};

/***************************************************************************
 *	menu_data ¤: ˥塼ܾ
 *	С
 *		type:			˥塼ܷ
 *		widgetName:		У̣٤ǤΤ߻ѡ̤
 *		myWidget:	
 *		function:		У̣٤ǤΤ߻ѡ̤
 ***************************************************************************/
struct menu_data {
	int type;
	String widgetName;
	Widget myWidget;
	void (*function)(Widget w, XtPointer client_data, XtPointer call_data);
};

/***************************************************************************
 *	menuData ¤: ˥塼
 *	С
 *		menuButton:		˥塼ܥΥå
 *		menu:			˥塼Υå
 *		menuName:		˥塼δ̾
 *		num:			˥塼ܤο
 *		info:			˥塼ܾ
 ***************************************************************************/
struct menuData {
	Widget menuButton;
	Widget menu;
	const char *menuName;
	int num;
	void (*popup)(Widget w, XtPointer client_data, XtPointer call_data);
	void (*popdown)(Widget w, XtPointer client_data, XtPointer call_data);
	struct menu_data *info;
};

/***************************************************************************
 *	modeSelector: ⡼˥塼
 *	С
 *		paneNo:			ֹ
 *		menuInfo:		˥塼
 *		blockNo:		֥åֹ
 *		partNo:			ֹ
 *		currentPane:	߹ܤξ
 *		blockTop:		⡼
 ***************************************************************************/
typedef struct _modeSelector {
	int paneNo;
	struct menuData *menuInfo;
	int blockNo;
	int partNo;
	struct menu_data *currentPane;
	struct _modeSelector *blockTop;
	XtPointer client_data;
} modeSelector;

/***************************************************************************
 *	selectorPanes: ⡼˥塼
 *	С
 *		
 *		   С̾   ա̣
 *		
 *		 0paneNo          ֹ桡
 *		
 *		 1panesInfo       ˥塼ܾ
 *		
 *		 2fileSelecterInfoե
 *		
 *		 3option          ץؿ
 *		
 *		 4client_data     
 *		
 ***************************************************************************/
typedef struct _selectorPanes {
	int paneNo;
	struct menu_data **panesInfo;
	FileSelctorInfo *fileSelecterInfo;
	void (*option)(Widget w, XtPointer client_data, XtPointer call_data);
	XtPointer client_data;
} selectorPanes;

/*****************************************************
 *	ץꥱ󡦥꥽Υ꥽̾饹̾
 *****************************************************/
#define XtNrecordingCmd		"recordingCmd"
#define XtCRecordingCmd		"RecordingCmd"
#define XtNplayingCmd		"playingCmd"
#define XtCPlayingCmd		"PlayingCmd"
#define XtNrecordingDev		"recordingDev"
#define XtCRecordingDev		"RecordingDev"
#define XtNplayingDev		"playingDev"
#define XtCPlayingDev		"PlayingDev"
#define XtNrecordingPcmIo	"recordingPcmIo"
#define XtCRecordingPcmIo	"RecordingPcmIo"
#define XtNplayingPcmIo		"playingPcmIo"
#define XtCPlayingPcmIo		"PlayingPcmIo"
#define XggCIoType			"IoType"
#define XggRPcmIoType		"PcmIoType"

/***************************************************************************
 --------------------------------------------------------------------------
	ץꥱ󡦥꥽
 --------------------------------------------------------------------------
 Name               Class              RepType         Default Value
 ----               -----              -------         -------------
 recordingCmd       RecordingCmd       String          "/bin/cat /dev/pcmrec"
 playingCmd         PlayingCmd         String          "/bin/cat -u > /dev/pcm"
 recordingDev       RecordingDev       String          NULL
 playingDev         PlayingDev         String          NULL
 recordingPcmIo     RecordingPcmIo     XggRPcmIoType   pcm8towns
 playingPcmIo       PlayingPcmIo       XggRPcmIoType   pcm8towns
 --------------------------------------------------------------------------

 ***************************************************************************/
/* data structure for application resources */
typedef struct {
	String recordingCmd;
	String playingCmd;
	String recordingDev;
	String playingDev;
	ioType recordingPcmIo;
	ioType playingPcmIo;
} AppData, *AppDataPtr;

/*********************
 *	ץȥ
 *********************/
void ExtVaSetSensitives(Boolean sensitive, ...);
void make_sndHeader(const char *name, long wsize, struct snd_head *head);
void encode2sndFormat(long wsize, unsigned char *pcmData_ptr);
int saveSndData(const char *filename, 
					const struct snd_head *head, unsigned char *buff);
int say_sample(const char *snd_file, int spos, int epos);
Widget loadDialogInit(Widget parent, Widget popupButton);
Widget saveDialogInit(Widget parent, Widget popupButton);

void quit(Widget w, XtPointer client_data, XtPointer call_data);
WavesLink *WaveListIndex(int index);
void makeMemoryList(void);
void DeleteMemory(Widget w, XtPointer client_data, XtPointer call_data);
WavesLink *WaveListShowCurrent(int def_index);
void SetRecordingTime(Widget w, long size);
void IncrementTime(Widget w, XtPointer client_data, XtPointer call_data);
void DecrmentTime(Widget w, XtPointer client_data, XtPointer call_data);
void initTimeChange(Widget w, XtPointer client_data, XtPointer call_data);
void memory_block_init(Widget parent);
static void MenuSelect(Widget w, XtPointer client_data, XtPointer garbage);
void makeMenu(Widget parent);

Boolean pcmEncoding(XtPointer client_data);
void pcmRecording(XtPointer client_data, int *source, XtInputId *id);
void pcmPlaying(XtPointer client_data, int *source, XtInputId *id);
void recordingStart(Widget w);
void playbackStart(Widget w);
void operationEnd(void);
void Recording(Widget w, XtPointer client_data, XtPointer call_data);
void Playing(Widget w, XtPointer client_data, XtPointer call_data);
void Stop(Widget w, XtPointer client_data, XtPointer call_data);
void Pause(Widget w, XtPointer client_data, XtPointer call_data);
static void ButtonOff(Widget w, XEvent *event, 
				String *params, Cardinal *num_params);
void rec_panel_init(XtAppContext app_context, Widget parent);

static WaveOrder *WaveUnitAlloc(size_t size);
WaveOrder *WaveMemoryAlloc(size_t size);
WavesLink *AllocTimes(size_t size);
void releaseWaveMemory(WaveOrder *wave);
void FreeWaves(WavesLink *wave);
void UnlinkWaves(WavesLink *wave);
WavesLink *linkLastWave(WavesLink *waves);
WavesLink *LinkedWaveAlloc(size_t size);
size_t getMemorySizeUnit(WaveOrder *wave);
size_t getEncodingSizeUnit(WaveOrder *wave);
size_t getRecordingSizeUnit(WaveOrder *wave);
size_t sizeOfWave(WaveOrder *wave, size_t (*getUnitSize)(WaveOrder *wave));
int NumOfList(const WavesLink *waves);
String *getMemoryList(const WavesLink *waveOrder, int *numOfList);
void WaveGarbageCollection(WaveOrder *wave);
WaveSearch *wave_search(WaveOrder *wave, size_t offset);
void WaveGraph(WavesLink *wave);
void graphRedraw(Widget w, XtPointer client_data, XtPointer call_data);

void WaveConvert(Widget w, XtPointer client_data, XtPointer call_data);
void WavePaste(Widget w, XtPointer client_data, XtPointer call_data);
void WaveCut(Widget w, XtPointer client_data, XtPointer call_data);
void waveClearCall(Widget w, XtPointer client_data, XtPointer call_data);
void waveCutCall(Widget w, XtPointer client_data, XtPointer call_data);
void waveCopyCall(Widget w, XtPointer client_data, XtPointer call_data);
void wavePasteCall(Widget w, XtPointer client_data, XtPointer call_data);
void waveUnselectCall(Widget w, XtPointer client_data, XtPointer call_data);
void OnceActionCall(Widget w, XEvent *event, 
							String *params, Cardinal *num_params);
void preFileMenu(Widget w, XtPointer client_data, XtPointer garbage);
void preSelectionMenu(Widget w, XtPointer client_data, XtPointer garbage);
void SetCurrentWaveName(WavesLink *wave);
int NumberOfPanes(const WavesLink *waves);
void load_chd(Widget w, XtPointer client_data, XtPointer call_data);
void save_chd(Widget w, XtPointer client_data, XtPointer call_data);
void selectorPane(Widget w, XtPointer client_data, XtPointer call_data);
void setPickup(Widget w, XtPointer client_data, XtPointer call_data);

Boolean XggTypeConverter(Display *dpy, XrmValue *args, Cardinal *num_args, 
				XrmValue *fromVal, XrmValue *toVal, XtPointer *converter_data);

#endif /*_GGXSND_H*/
