/****************************************************************************
 *	rec_panel: Recorder Panel ѥͥ
 *
 *			Date. 1994/07/20 --
 *				Programed by Nobuyuki Maruichi
 *				Adviced by S.Kouno
 *	Note.
 *			SHIFT JIS Kanji Code / JIS X0208-1990
 *			Tab Size 4 / Shift Width = 4
 *	from
 *		mixcd.c(maxcd.c)
 *		PCM player T-E-S-T program  Copyright (C) 1993 S.Kouno
 *		PCM recording T-E-S-T program  Copyright (C) 1993 S.Kouno
 *		
 ***************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
/*
 * Include files required for all Toolkit programs
 */
#include <X11/Intrinsic.h>	/* Intrinsics Definitions */
#include <X11/StringDefs.h>	/* Standard Name-String definitions */
#include <X11/Core.h>
#include <X11/Shell.h>

/*
 *	Public include file for widgets we actually use in this file.
 */
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Repeater.h>
#include <X11/Xaw/Toggle.h>
#include <X11/Xaw/Paned.h>
#include <X11/Xaw/List.h>
#include <X11/Xaw/Viewport.h>

/*
 *	CD ѤΥإåե
 */
#include <fcntl.h>
#include <sys/ioctl.h>
#include <linux/fmmidi.h>
#include "snd.h"
#include "ggxsnd.h"

/*
 *	CD ѥܥΥӥåȥޥå
 */
#include "bitmaps/eject.xbm"	/* ȡܥ */
#include "bitmaps/rec.xbm"		/*    : Ͽܥ */
#include "bitmaps/rew.xbm"		/* |:  */
#include "bitmaps/ff.xbm"		/* |:  */
#include "bitmaps/play.xbm"		/*  | : ܥ */
#include "bitmaps/stop.xbm"		/*    : ߥܥ */
#include "bitmaps/pause.xbm"	/*  ||  : ߥܥ */

extern Widget memoryList;
extern Widget clearMemory, newMemory, editMemory, deleteMemory, enterMemory;
extern Widget fileMenuButton;

static Widget pcmPanel, rec, play, stop, rew, ff, pause;

extern long MinuteSize;
extern long SecondSize;
extern long CentiSecSize;
extern long currentSize;
extern long unitSize;
extern long deltaSize;
extern int recTimeResizeCounter;
extern Widget topLevel;
extern char ggxsndTitle[];
extern const char *pcmIoName[];

extern AppData app_data;

operationControl *Operation = NULL;
operationControl recordingOperation = {
	opRecord, 
};
operationControl playingOperation;

void operationEnd(void);

/***************************************************************************
 *	pcm16setSndMode: 16bit-PCM  SND ꤹ
 *	
 *		void pcm16setSndMode(int fd);
 *	
 *		int fd;		եǥץ
 *	֤
 *		ʤ
 *	
 *		TOWNS 8bit PCM ȸߴΥ⡼ɤꤹ롣
 *		16bit PCM Ǥϡ8 bit PCM Ȱۤʤꡢ⡼ѹ ioctl() Ѥ
 *		
 *		
 ***************************************************************************/
void pcm16setSndMode(int fd)
{
	ioctl(fd, PCM16_CTL_SNDWAV, 1);				/* select snd */
	ioctl(fd, PCM16_CTL_STMONO, 0);				/* stereo/mono */
	ioctl(fd, PCM16_CTL_BITS, 0);				/* 8/16 bits */
	ioctl(fd, PCM16_CTL_RATE, PCM16_RATE19K);	/* samplerate  set */
}

/***************************************************************************
 *	pcmEncoding: ȷǡѴؿXtAppAddWorkProc() Хåؿ
 *	
 *		Boolean pcmEncoding(XtPointer client_data);
 *	
 *		XtPointer client_data;	Ͽѥǡ¤Τؤݥ
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
Boolean pcmEncoding(XtPointer client_data)
{
	Boolean workProcIsOver = True;
	size_t nbytes;
	WaveOrder **encodingMemory = client_data;

#ifdef	DEBUG
	printf("Now encoding!!\n");	fflush(stdout);
#endif	/*DEBUG*/
	if((encodingMemory != NULL)?(*encodingMemory != NULL):(0)) {
		nbytes = (*encodingMemory)->recording_size
									- (*encodingMemory)->encoding_size; 
		if(app_data.recordingPcmIo == pcm8towns) {
			encode2sndFormat(nbytes, 
				(*encodingMemory)->pcm_wave + (*encodingMemory)->encoding_size);
		}

		(*encodingMemory)->encoding_size += nbytes;
		/*printf("encording size = %d.(%d/%d)\n", nbytes, 
			(*encodingMemory)->encoding_size, (*encodingMemory)->recording_size);*/

		if((*encodingMemory)->encoding_size >= (*encodingMemory)->wave_size) {
			if((*encodingMemory)->next_ptr != NULL) {
				*encodingMemory = (*encodingMemory)->next_ptr;
				workProcIsOver = False;
			}
		}
	}
	if(workProcIsOver && recordingOperation.wave != NULL) {
		WaveGraph(recordingOperation.wave);
	/*	printf("Wave is \"%s\"\n", recordingOperation.wave->wave_name);*/
		WaveRename(recordingOperation.wave);
		SetCurrentWaveName(recordingOperation.wave);
		makeMemoryList();
	}
	return(workProcIsOver);
}

/***************************************************************************
 *	pcmRecording: УãϿؿXtAppAddInput() Хåؿ
 *	
 *		void pcmRecording(XtPointer client_data, int *source, XtInputId *id);
 *	
 *		XtPointer client_data;	Ͽѥǡ¤Τؤݥ
 *		int *source;			ϿѤΥե뵭һҡ̾/dev/pcmrec
 *		XtInputId *id;			XtAppAddInput()  ID
 *	֤
 *		ʤ
 *	
 *		ե뵭һҤϡ̾ 8bit-PCM Ǥϡ/dev/pcmrec16bit-PCM 
 *		ϡ/dev/pcm16rec
 *		ѥץ饤ǽβǽ⤢롢ϡưƥѤǤ
 *		
 ***************************************************************************/
void pcmRecording(XtPointer client_data, int *source, XtInputId *id)
{
	size_t nbytes, recCounter;
	WaveOrder **recordingMemory = client_data;

#ifdef	DEBUG
	printf("Now recording!!\n");	fflush(stdout);
#endif	/*DEBUG*/
	if((recordingMemory != NULL)?(*recordingMemory != NULL):(0)) {
		/*do*/ {
			recCounter = (*recordingMemory)->recording_size;
			while(recCounter < (*recordingMemory)->wave_size) {
#ifdef	SYSTEM_CALL
				nbytes = read(*source, (*recordingMemory)->pcm_wave, 
							(*recordingMemory)->wave_size - recCounter);
#else
				nbytes = fread((*recordingMemory)->pcm_wave, 1,
							(*recordingMemory)->wave_size - recCounter, 
							Operation->stream);
#endif	/*SYSTEM_CALL*/
				if(nbytes > 0) {
					recCounter += nbytes;
				} else {
					if(nbytes == -1) {
						perror("pcmRecording");
					}
					break;
				}
			}
			(*recordingMemory)->recording_size = recCounter;
			if(recCounter >= (*recordingMemory)->wave_size) {
				if((*recordingMemory)->next_ptr != NULL) {
					*recordingMemory = (*recordingMemory)->next_ptr;
				} else {
					operationEnd();
					XtVaSetValues(rec, XtNstate, False, NULL);
					ExtVaSetSensitives(True, fileMenuButton, memoryList, 
							clearMemory, deleteMemory, editMemory, NULL);
					makeMemoryList();
				}
			}
		} /*while((*recordingMemory)->next_ptr != NULL);*/
	}
}

/***************************************************************************
 *	pcmPlaying: УãͺؿXtAppAddInput() Хåؿ
 *	
 *		void pcmPlaying(XtPointer client_data, int *source, XtInputId *id);
 *	
 *		XtPointer client_data;	ѥǡ¤Τؤݥ
 *		int *source;			ѤΥե뵭һ
 *		XtInputId *id;			XtAppAddInput()  ID
 *	֤
 *		ʤ
 *	
 *		ե뵭һҤϡ̾ 8bit-PCM Ǥϡ/dev/pcm16bit-PCM Ǥϡ
 *		/dev/pcm16
 *		ѥץ饤ǽβǽ⤢롢ϡưƥѤǤ
 *		
 ***************************************************************************/
void pcmPlaying(XtPointer client_data, int *source, XtInputId *id)
{
	size_t nbytes, playCounter, currentPlayingSize;
	WaveOrder **playingMemory = client_data;

#ifdef	DEBUG
	printf("Now playing!!\n");	fflush(stdout);
#endif	/*DEBUG*/
	if((playingMemory != NULL)?(*playingMemory != NULL):(0)) {
		/*while((*playingMemory)->next_ptr != NULL)*/ {
			playCounter = Operation->current_size;
			/*while(playCounter < (*playingMemory)->encoding_size)*/ {
				currentPlayingSize = (*playingMemory)->encoding_size - playCounter;
				if(Operation->playing_size < currentPlayingSize) {
					currentPlayingSize = Operation->playing_size;
				}
#ifndef	SYSTEM_CALL
				nbytes = write(*source, 
								(*playingMemory)->pcm_wave + playCounter, 
													currentPlayingSize);
#else
				nbytes = fwrite((*playingMemory)->pcm_wave, 1, 
								currentPlayingSize, Operation->stream);
#endif	/*SYSTEM_CALL*/
				if(nbytes > 0) {
					playCounter += nbytes;
					Operation->playing_size -= nbytes;
				} else {
					if(nbytes == -1) {
						perror("pcmPlaying");
					}
					/*break;*/
				}
			}
			Operation->current_size = playCounter;
			if(Operation->playing_size > 0) {
				if(playCounter >= (*playingMemory)->encoding_size) {
					if((*playingMemory)->next_ptr != NULL) {
						*playingMemory = (*playingMemory)->next_ptr;
						Operation->current_size = 0;
					} else {
						operationEnd();
						XtVaSetValues(play, XtNstate, False, NULL);
						ExtVaSetSensitives(True, fileMenuButton, memoryList, 
								clearMemory, deleteMemory, editMemory, NULL);
						makeMemoryList();
					}
				}
			} else {
				operationEnd();
				XtVaSetValues(play, XtNstate, False, NULL);
				ExtVaSetSensitives(True, fileMenuButton, memoryList, 
						clearMemory, deleteMemory, editMemory, NULL);
				makeMemoryList();
			}
		}
	}
}

/***************************************************************************
 *	recordingStart: Ͽϴؿ
 *	
 *		void recordingStart(Widget w);
 *	
 *		Widget w;		ץꥱ󡦥ƥȼ
 *	֤
 *		ʤ
 *	
 *		̤˥ե륪ץȥץ󥰥졼ȤʤɤνԤޤ
 *		
 ***************************************************************************/
void recordingStart(Widget w)
{
	char recordingTitle[256];
#ifdef	DEBUG
	printf("Recording start!!\n");	fflush(stdout);
#endif	/*DEBUG*/
	if(app_data.recordingDev != NULL) {
		sprintf(recordingTitle, "ggxsnd -- recording (%s:%s) --", 
				app_data.recordingDev, pcmIoName[app_data.recordingPcmIo]);
		XtVaSetValues(topLevel, XtNtitle, recordingTitle, NULL);
		recordingOperation.stream = fopen(app_data.recordingDev, "r");
	} else {
		sprintf(recordingTitle, "ggxsnd -- recording (%s:%s) --", 
				app_data.recordingCmd, pcmIoName[app_data.recordingPcmIo]);
		XtVaSetValues(topLevel, XtNtitle, recordingTitle, NULL);
		recordingOperation.stream = popen(app_data.recordingCmd, "r");
	}
	if(recordingOperation.stream != NULL) {
		/*printf("Recording start!!\n");	fflush(stdout);*/
		recordingOperation.current_wave = recordingOperation.wave->wave;
		recordingOperation.waveOperationStart = recordingOperation.current_wave;
		/*recordingOperation.current_wave->recording_size = 0;*/
		recordingOperation.id = 
				XtAppAddInput(XtWidgetToApplicationContext(w), 
							fileno(recordingOperation.stream), 
							(XtPointer)XtInputReadMask, 
							pcmRecording, &recordingOperation.current_wave);
		if(app_data.recordingPcmIo == pcm16towns) {
			/*************************************
			 *	16 bit PCM Ѥξν
			 *	
			 *		ǡTOWNS SND 
			 *		ͥ롧Υ
			 *		̻Ҳ̡8bit
			 *		ץ󥰥졼ȡ19.2kHz
			 *************************************/
			pcm16setSndMode(fileno(recordingOperation.stream));
		}
		/*printf("Recording start!! Pipe open suceeded.\n");	fflush(stdout);*/
	} else {
		/*printf("Recording start!! Pipe open failed.\n");	fflush(stdout);*/
	}
}

/***************************************************************************
 *	playbackStart: ϴؿ
 *	
 *		void playbackStart(Widget w);
 *	
 *		Widget w;		ץꥱ󡦥ƥȼ
 *	֤
 *		ʤ
 *	
 *		̤˥ե륪ץȥץ󥰥졼ȤʤɤνԤޤ
 *		
 ***************************************************************************/
void playbackStart(Widget w)
{
	static WaveOrder *playingMemory;
	char playingTitle[256];
	
	/*printf("playbackStart!! End\n");*/
	if(playingOperation.current_wave != NULL) {
		playingMemory = playingOperation.current_wave;
	} else {
		playingMemory = playingOperation.wave->wave;
	}
#ifdef	DEBUG
	playingOperation.stream = fopen("pcm.snd", "w");
#endif	/*DEBUG*/
	if(app_data.playingDev != NULL) {
		sprintf(playingTitle, "ggxsnd -- playing (%s:%s) --", 
				app_data.playingDev, pcmIoName[app_data.playingPcmIo]);
		XtVaSetValues(topLevel, XtNtitle, playingTitle, NULL);
		playingOperation.stream = fopen(app_data.playingDev, "w");
	} else {
		sprintf(playingTitle, "ggxsnd -- playing (%s:%s) --", 
				app_data.playingCmd, pcmIoName[app_data.playingPcmIo]);
		XtVaSetValues(topLevel, XtNtitle, playingTitle, NULL);
		playingOperation.stream = popen(app_data.playingCmd, "w");
	}
	if(playingOperation.stream != NULL) {
		playingOperation.id = XtAppAddInput(XtWidgetToApplicationContext(w), 
									fileno(playingOperation.stream), 
									(XtPointer)XtInputWriteMask, 
									pcmPlaying, &playingMemory);
		if(app_data.playingPcmIo == pcm16towns) {
			/*************************************
			 *	16 bit PCM Ѥξν
			 *	
			 *		ǡTOWNS SND 
			 *		ͥ롧Υ
			 *		̻Ҳ̡8bit
			 *		ץ󥰥졼ȡ19.2kHz
			 *************************************/
			pcm16setSndMode(fileno(playingOperation.stream));
		} else {
			/***********************************
			 *	8 bit PCM Ѥξν
			 *	
			 *		ץ󥰥졼ȡ19.2kHz
			 ***********************************/
#ifndef	SYSTEM_CALL
			write(fileno(playingOperation.stream), 
								&playingOperation.wave->header.rate, 
								sizeof(playingOperation.wave->header.rate));
#else
			fwrite(&playingOperation.wave->header.rate, 
					sizeof(playingOperation.wave->header.rate), 
									1, playingOperation.stream);
#endif	/*SYSTEM_CALL*/
			/*printf("playbackStart!! Pipe open.\n");*/
		}
	}
	/*printf("playbackStart!! End\n");*/
}

/***************************************************************************
 *	operationEnd: Ͽλؿ
 *	
 *		void operationEnd(void);
 *	
 *		ʤ
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void operationEnd(void)
{
	if((Operation != NULL)?(Operation->stream != NULL):(0)) {
		XtRemoveInput(Operation->id);
		fclose(Operation->stream);
		XtVaSetValues(topLevel, XtNtitle, ggxsndTitle, NULL);
		Operation->stream = NULL;
		if(Operation->command_type == opRecord) {
			WaveGarbageCollection(Operation->wave->wave);
			Operation->wave->header.length = 
					sizeOfWave(Operation->wave->wave, getRecordingSizeUnit);
		}
		if(Operation->finishedOperation != NULL) {
			XtAppAddWorkProc(XtWidgetToApplicationContext(rec), 
				Operation->finishedOperation, &Operation->waveOperationStart);
		}
	}
}

/***************************************************************************
 *	Recording: Ͽܥrec åȡХåؿ
 *	
 *		void Recording(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		ʤ
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void Recording(Widget w, XtPointer client_data, XtPointer call_data)
{
	Boolean recFlag;

	XtVaGetValues(w, XtNstate, &recFlag, NULL);
	if(recFlag == True) {
		operationEnd();
		recordingOperation.startOperation = recordingStart;
		recordingOperation.stream = NULL;
		recordingOperation.wave = NULL;
		recordingOperation.finishedOperation = pcmEncoding;
		XtVaSetValues((Widget)client_data, XtNstate, recFlag, NULL);
		recordingOperation.wave = LinkedWaveAlloc(currentSize);
		Operation = &recordingOperation;
		makeMemoryList();
		ExtVaSetSensitives(False, fileMenuButton, memoryList, 
							clearMemory, deleteMemory, editMemory, NULL);
	}
}

/***************************************************************************
 *	Playing: ܥplay åȡˤΥХåؿ
 *	
 *		void Playing(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void Playing(Widget w, XtPointer client_data, XtPointer call_data)
{
	size_t begin, end, waveSize;
	Boolean playFlag, pauseFlag;
	WaveSearch *searching_ptr;
	extern Widget pcmWave;
	extern WavesLink *currentWaves;
	/*extern WavesLink *memoryListTop;*/

	XtVaGetValues(w, XtNstate, &playFlag, NULL);
	
	if(playFlag == True) {
		operationEnd();
		playingOperation.stream = NULL;
		Operation = &playingOperation;
		playingOperation.wave = currentWaves;
		if(playingOperation.wave == NULL) {
			/* ٤ǡʤ */
			XtVaSetValues(w, XtNstate, False, NULL);
		} else {
			waveSize = sizeOfWave(currentWaves->wave, getEncodingSizeUnit);
			if(SelectArea(pcmWave, &begin, &end)) {
				if(begin < 0)
					begin = 0;
				if(end < 0)
					end = waveSize;
			} else {
				begin = 0;
				end = waveSize;
			}
			searching_ptr = wave_search(currentWaves->wave, begin);
			if(searching_ptr != NULL) {
				playingOperation.current_wave = searching_ptr->wave_ptr;
				playingOperation.current_size = searching_ptr->offset;
			} else {
				playingOperation.current_wave = currentWaves->wave;
				playingOperation.current_size = 0;
			}
			playingOperation.playing_size = end - begin;
			/*playingOperation.wave = WaveListShowCurrent(1);*/

			playingOperation.startOperation = playbackStart;
			playingOperation.finishedOperation = NULL;
			XtVaGetValues((Widget)client_data, XtNstate, &pauseFlag, NULL);
			if(pauseFlag == False) {
				ExtVaSetSensitives(False, fileMenuButton, memoryList, 
								clearMemory, deleteMemory, editMemory, NULL);
				playingOperation.startOperation(w);
			}
		}
	}
}

/***************************************************************************
 *	Stop: ߥܥstop åȡˤΥХåؿ
 *	
 *		void Stop(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void Stop(Widget w, XtPointer client_data, XtPointer call_data)
{
	Boolean playFlag;

	XtVaGetValues(w, XtNstate, &playFlag, NULL);
	operationEnd();
	Operation = NULL;
	ExtVaSetSensitives(True, fileMenuButton, memoryList, 
							clearMemory, deleteMemory, editMemory, NULL);
	makeMemoryList();
}

/***************************************************************************
 *	Pause: ߥܥpause åȡˤΥХåؿ
 *	
 *		void Pause(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				pause ѤΥå
 *		XtPointer client_data;	̤
 *		XtPointer call_data;	̤
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void Pause(Widget w, XtPointer client_data, XtPointer call_data)
{
	Boolean pauseFlag;

	XtVaGetValues(w, XtNstate, &pauseFlag, NULL);
	if(pauseFlag == False) {
		operationEnd();
		if((Operation != NULL)?(Operation->startOperation != NULL):(0)) {
			Operation->startOperation(w);
		}
	} else {
		operationEnd();
	}
}

/***************************************************************************
 *	ButtonOff: ܥ󡦥մؿbuttonOff 
 *	
 *		static void ButtonOff(Widget w, XEvent *event, 
 *								String *params, Cardinal *num_params);
 *	
 *		Widget w;				̤
 *		XEvent *event;			̤
 *		String *params;			̤
 *		Cardinal *num_params;	̤
 *	֤
 *		ʤ
 *	
 *		ߥܥstop åȡˤɲä륢
 *		ǽϡϿߤγƥܥ򥪥դˤ롣
 *		
 ***************************************************************************/
/*ARGSUSED*/
static void ButtonOff(Widget w, XEvent *event, String *params, Cardinal *num_params)
{
	Boolean buttonStatus;

	XtVaGetValues(rec, XtNstate, &buttonStatus, NULL);
	if(buttonStatus == True) {
		XtCallActionProc(rec, "unset", event, params, *num_params);
	}
	XtVaGetValues(play, XtNstate, &buttonStatus, NULL);
	if(buttonStatus == True) {
		XtCallActionProc(play, "unset", event, params, *num_params);
	}
	XtVaGetValues(pause, XtNstate, &buttonStatus, NULL);
	if(buttonStatus == True) {
		XtCallActionProc(pause, "unset", event, params, *num_params);
	}
}

/***************************************************************************
 *	rec_panel_init: Ͽѥͥ
 *	
 *		void rec_panel_init(XtAppContext app_context, Widget parent);
 *	
 *		XtAppContext app_context;	ץꥱ󡦥ƥ
 *		Widget parent;				ƥå
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void rec_panel_init(XtAppContext app_context, Widget parent)
{
	static XtActionsRec stop_actions[] = {
		{"buttonOff",	ButtonOff}
	};
	extern Pixmap recPixmap, rewPixmap, ffPixmap, playPixmap;
	extern Pixmap stopPixmap, pausePixmap;

	XtAppAddActions(app_context, stop_actions, XtNumber(stop_actions));

	pcmPanel = XtVaCreateManagedWidget(
		"pcmPanel", 		/* arbitrary widget name */
		panedWidgetClass,	/* widget class from Form.h */
		parent,				/* parent widget */
		NULL);				/* tarminate varargs list */

	rec = XtVaCreateManagedWidget(
		"rec", 				/* widget name */
		toggleWidgetClass,	/* widget class from Toggle.h */
		pcmPanel, 			/* parent widget */
		XtNbitmap, recPixmap,
		NULL);				/* tarminate varargs list */

	rew = XtVaCreateManagedWidget(
		"rew", 				/* arbitrary widget name */
		repeaterWidgetClass,	/* widget class from Command.h */
		pcmPanel,	 		/* parent widget */
		XtNbitmap, rewPixmap,
		NULL);				/* tarminate varargs list */

	play = XtVaCreateManagedWidget(
		"play", 			/* arbitrary widget name */
		toggleWidgetClass,	/* widget class from Command.h */
		pcmPanel,	 		/* parent widget */
		XtNbitmap, playPixmap, 
		NULL);				/* tarminate varargs list */

	ff = XtVaCreateManagedWidget(
		"ff", 				/* arbitrary widget name */
		repeaterWidgetClass,	/* widget class from Command.h */
		pcmPanel,		 	/* parent widget */
		XtNbitmap, ffPixmap, 
		NULL);				/* tarminate varargs list */

	stop = XtVaCreateManagedWidget(
		"stop", 			/* arbitrary widget name */
		commandWidgetClass,	/* widget class from Command.h */
		pcmPanel,		 	/* parent widget */
		XtNbitmap, stopPixmap, 
		NULL);				/* tarminate varargs list */

	pause = XtVaCreateManagedWidget(
		"pause", 			/* arbitrary widget name */
		toggleWidgetClass,	/* widget class from Toggle.h */
		pcmPanel,		 	/* parent widget */
		XtNbitmap, pausePixmap, 
		NULL);				/* tarminate varargs list */

	XawToggleChangeRadioGroup(rec, play);
	XtAddCallback(  rec, XtNcallback, Recording, pause);
	XtAddCallback( play, XtNcallback,   Playing, pause);
	XtAddCallback( stop, XtNcallback,      Stop, NULL);
	XtAddCallback(pause, XtNcallback,     Pause, NULL);
}

