/****************************************************************************
 *	snd_file: *.snd ե
 *
 *		Date. 1994/09/06 -- 1995/7/5
 *		Date. 1998/05/15 --          (Debian GNU/Linux for TOWNS support)
 *		
 *			Programed by Nobuyuki Maruichi
 *			Adviced by S.Kouno
 *
 *	Note.
 *			SHIFT JIS Kanji Code / JIS X0208-1983
 *			Tab Size 4 / Shift Width = 4
 *	from
 *		mixcd.c(maxcd.c)
 *		PCM player T-E-S-T program  Copyright (C) 1993 S.Kouno
 *		PCM recording T-E-S-T program  Copyright (C) 1993 S.Kouno
 ***************************************************************************/

/***********************************************
 *	Ūʥ󥯥롼ɡե
 ***********************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>
#include <fcntl.h>

/***********************************************
 *	X Toolkit δŪʥ󥯥롼ɡե
 ***********************************************/
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Core.h>
#include <X11/Shell.h>

/*****************************************
 *	Atena Widget Υ󥯥롼ɡե
 *****************************************/
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Repeater.h>
#include <X11/Xaw/Toggle.h>
#include <X11/Xaw/Paned.h>
#include <X11/Xaw/List.h>
#include <X11/Xaw/Viewport.h>
#include <X11/Xaw/Dialog.h>
#include <X11/Xaw/AsciiText.h>
#include <X11/Xaw/Text.h>
#include <X11/Xaw/TextSrc.h>
#include <X11/Xaw/TextSink.h>
#include <X11/Xaw/AsciiSrc.h>
#include <X11/Xaw/AsciiSink.h>

/*******************************
 *	ѤΥإåե
 *******************************/
#include "snd.h"
#include "ggxsnd.h"
#include "xfile.h"

String NewSndNameAlloc(struct snd_head *sndFileHeader);

extern long MinuteSize;
extern long SecondSize;
extern long CentiSecSize;
extern long currentSize;
extern long unitSize;
extern long deltaSize;
extern int recTimeResizeCounter;

Widget pLoadShell, pcmLoadDialog;
Widget pSaveShell, pcmSaveDialog;
Widget pcmLoadView, pcmLoadList;
Widget pcmSaveView, pcmSaveList;
Widget pcmLoadDir;
Widget pcmSaveDir;

extern char *filePickup;
extern char *wildCard;
extern int (*sort_comp)(const void *file1, const void *file2);

void setSortFunc(Widget w, XtPointer client_data, XtPointer call_data);

operationControl *fileOperation = NULL;
operationControl loadingOperation;
operationControl savingOperation;

FileSelctorInfo loadFileSelecterInfo;
FileSelctorInfo saveFileSelecterInfo;

/***************************************************************************
 *	menu_data ¤: ˥塼ܾ
 *	С
 *		type:			˥塼ܷ
 *		widgetName:		У̣٤ǤΤ߻ѡ̤
 *		myWidget:	
 *		function:		У̣٤ǤΤ߻ѡ̤
 *		
 *		̡widgetName        function  
 *		
 *		-- SmeBSB ---------------     ----    ˥塼ȥ롡
 *		
 *		 0 SmeLineloadMenuTopLine     ----    ڤΥ饤󡡡
 *		
 *		 1 SmeBSB allFile         selectorPaneե븡С
 *		
 *		 2 SmeBSB wildCard        selectorPane
 *		
 *		 3 SmeBSB sndFileOnly     selectorPaneӣΣĥե롡
 *		
 *		 4 SmeLineloadMenuLine        ----    ڤΥ饤󡡡
 *		
 *		 5 SmeBSB nonSort         selectorPaneȤʤ
 *		
 *		 6 SmeBSB asciiSort       selectorPaneȡ
 *		
 *		 7 SmeBSB suffixSort      selectorPaneեåȨ
 *		
 *		 8 SmeBSB dateSort        selectorPaneս祽ȡ
 *		
 *		 9 SmeBSB sizeSort        selectorPaneȡ
 *		
 *		10 SmeBSB       ----          ----    
 *		
 ***************************************************************************/
struct menu_data loadMenuInfo[] = {
	{TypeSmeLine, "loadMenuTopLine", NULL, NULL},
	{TypeSmeBSB,  "allFile",		 NULL, selectorPane}, 
	{TypeSmeBSB,  "wildCard",		 NULL, selectorPane}, 
	{TypeSmeBSB,  "sndFileOnly",	 NULL, selectorPane},
	{TypeSmeLine, "loadMenuLine",	 NULL, NULL},
	{TypeSmeBSB,  "nonSort",		 NULL, selectorPane},
	{TypeSmeBSB,  "asciiSort",		 NULL, selectorPane},
	{TypeSmeBSB,  "suffixSort",		 NULL, selectorPane},
	{TypeSmeBSB,  "dateSort",		 NULL, selectorPane},
	{TypeSmeBSB,  "sizeSort",		 NULL, selectorPane},
	{EOF, NULL, NULL, NULL}
};

/***************************************************************************
 *	ɤ߹ߥ˥塼loadMenus
 *		
 *		С̾ա̣
 *		
 *		 0menuButton˥塼ܥΥåȨmakeMenus() Ǻ
 *		
 *		 1menu      ˥塼ΥåȡmakeMenus() Ǻ
 *		
 *		 2menuName  ˥塼δ̾"loadMenu"
 *		
 *		 3num       ˥塼ܤο10
 *		
 *		 4popup     ݥåץåפǼ¹ԤؿNULLʤʤˡ
 *		
 *		 5popdown   ݥåץǼ¹ԤؿNULLʤʤˡ
 *		
 *		 6info      ˥塼ܾ󡡡loadMenuInfo
 *		
 ***************************************************************************/
struct menuData loadMenus = {
	NULL,
	NULL,
	"loadMenu", 
	sizeof(loadMenuInfo) / sizeof(loadMenuInfo[0]) - 1,
	NULL, 
	NULL, 
	loadMenuInfo
};

/***************************************************************************
 *	ɤ߹ߥ˥塼եܤؤݥloadFileSelectors
 *		
 *		ա̣
 *		
 *		 0ܣե븡С
 *		
 *		 1ܣ
 *		
 *		 2ܣӣΣĥե븡С
 *		
 *		 3      
 *		
 ***************************************************************************/
struct menu_data *loadFileSelectors[] = {
	&loadMenuInfo[1], &loadMenuInfo[2], &loadMenuInfo[3], NULL
};

/***************************************************************************
 *	ɤ߹ߥ˥塼ե븡loadPickupPaneInfo
 *		
 *		 ؿ ա̣
 *		
 *		 0setPickup ؿꨢե븡С
 *		
 *		 1   NULL   
 *		
 *		 2setPickup ؿꨢӣΣĥե븡С
 *		
 *		EOF 
 *		
 ***************************************************************************/
selectorPanes loadPickupPaneInfo[] = {
	{ 0, loadFileSelectors, &loadFileSelecterInfo, setPickup, NULL}, 
	{ 1, loadFileSelectors, &loadFileSelecterInfo, NULL, NULL},
	{ 2, loadFileSelectors, &loadFileSelecterInfo, setPickup, "*.snd"},
	{ EOF, NULL, NULL, NULL, NULL}
};

/***************************************************************************
 *	ɤ߹ߥ˥塼ܤؤݥloadSortSelectors
 *		
 *		ա̣
 *		
 *		 0ܣ
 *		
 *		 1ܣ
 *		
 *		 2ܣ
 *		
 *		 3ܣ
 *		
 *		 4ܣ
 *		
 *		 5      
 *		
 ***************************************************************************/
struct menu_data *loadSortSelectors[] = {
	&loadMenuInfo[5], &loadMenuInfo[6], &loadMenuInfo[7],
	&loadMenuInfo[8], &loadMenuInfo[9], NULL
};

/***************************************************************************
 *	ɤ߹ߥ˥塼ե륽ȾloadSortPaneInfo
 *		
 *		ؿա̣
 *		
 *		 0setSortFunc 򨢥Ȥʤ
 *		
 *		 1setSortFunc ASCII ȡ
 *		
 *		 2setSortFunc Suffixȡ
 *		
 *		 3setSortFunc եȡ
 *		
 *		 4setSortFunc 򨢥ե륵ȡ
 *		
 *		EOF 
 *		
 ***************************************************************************/
selectorPanes loadSortPaneInfo[] = {
	{ 0, loadSortSelectors, &loadFileSelecterInfo, setSortFunc, NULL}, 
	{ 1, loadSortSelectors, &loadFileSelecterInfo, setSortFunc, ascii_comp}, 
	{ 2, loadSortSelectors, &loadFileSelecterInfo, setSortFunc, suffix_comp}, 
	{ 3, loadSortSelectors, &loadFileSelecterInfo, setSortFunc, date_comp}, 
	{ 4, loadSortSelectors, &loadFileSelecterInfo, setSortFunc, size_comp}, 
	{ EOF, NULL, NULL, NULL, NULL}
};

/***************************************************************************
 *	menu_data ¤: ˥塼ܾ
 *	С
 *		type:			˥塼ܷ
 *		widgetName:		У̣٤ǤΤ߻ѡ̤
 *		myWidget:	
 *		function:		У̣٤ǤΤ߻ѡ̤
 *		
 *		̡widgetName        function  
 *		
 *		-- SmeBSB ---------------     ----    ˥塼ȥ롡
 *		
 *		 0 SmeLinesaveMenuTopLine     ----    ڤΥ饤󡡡
 *		
 *		 1 SmeBSB allFile         selectorPaneե븡С
 *		
 *		 2 SmeBSB wildCard        selectorPane
 *		
 *		 3 SmeBSB sndFileOnly     selectorPaneӣΣĥե롡
 *		
 *		 4 SmeLinesaveMenuLine        ----    ڤΥ饤󡡡
 *		
 *		 5 SmeBSB nonSort         selectorPaneȤʤ
 *		
 *		 6 SmeBSB asciiSort       selectorPaneȡ
 *		
 *		 7 SmeBSB suffixSort      selectorPaneեåȨ
 *		
 *		 8 SmeBSB dateSort        selectorPaneս祽ȡ
 *		
 *		 9 SmeBSB sizeSort        selectorPaneȡ
 *		
 *		10 SmeBSB       ----          ----    
 *		
 ***************************************************************************/
struct menu_data saveMenuInfo[] = {
	{TypeSmeLine, "saveMenuTopLine", NULL, NULL},
	{TypeSmeBSB,  "allFile",		 NULL, selectorPane}, 
	{TypeSmeBSB,  "wildCard",		 NULL, selectorPane}, 
	{TypeSmeBSB,  "sndFileOnly",	 NULL, selectorPane},
	{TypeSmeLine, "saveMenuLine",	 NULL, NULL},
	{TypeSmeBSB,  "nonSort",		 NULL, selectorPane},
	{TypeSmeBSB,  "asciiSort",		 NULL, selectorPane},
	{TypeSmeBSB,  "suffixSort",		 NULL, selectorPane},
	{TypeSmeBSB,  "dateSort",		 NULL, selectorPane},
	{TypeSmeBSB,  "sizeSort",		 NULL, selectorPane},
	{EOF, NULL, NULL, NULL}
};

/***************************************************************************
 *	ɤ߹ߥ˥塼saveMenus
 *		
 *		С̾ա̣
 *		
 *		 0menuButton˥塼ܥΥåȨmakeMenus() Ǻ
 *		
 *		 1menu      ˥塼ΥåȡmakeMenus() Ǻ
 *		
 *		 2menuName  ˥塼δ̾"saveMenu"
 *		
 *		 3num       ˥塼ܤο10
 *		
 *		 4popup     ݥåץåפǼ¹ԤؿNULLʤʤˡ
 *		
 *		 5popdown   ݥåץǼ¹ԤؿNULLʤʤˡ
 *		
 *		 6info      ˥塼ܾ󡡡saveMenuInfo
 *		
 ***************************************************************************/
struct menuData saveMenus = {
	NULL,
	NULL,
	"saveMenu", 
	sizeof(saveMenuInfo) / sizeof(saveMenuInfo[0]) - 1,
	NULL, 
	NULL, 
	saveMenuInfo
};

/***************************************************************************
 *	ɤ߹ߥ˥塼եܤؤݥloadFileSelectors
 *		
 *		ա̣
 *		
 *		 0ܣե븡С
 *		
 *		 1ܣ
 *		
 *		 2ܣӣΣĥե븡С
 *		
 *		 3      
 *		
 ***************************************************************************/
struct menu_data *saveFileSelectors[] = {
	&saveMenuInfo[1], &saveMenuInfo[2], &saveMenuInfo[3], NULL
};

/***************************************************************************
 *	ɤ߹ߥ˥塼ե븡loadPickupPaneInfo
 *		
 *		 ؿ ա̣
 *		
 *		 0setPickup ؿꨢե븡С
 *		
 *		 1   NULL   
 *		
 *		 2setPickup ؿꨢӣΣĥե븡С
 *		
 *		EOF 
 *		
 ***************************************************************************/
selectorPanes savePickupPaneInfo[] = {
	{ 0, saveFileSelectors, &saveFileSelecterInfo, setPickup, NULL}, 
	{ 1, saveFileSelectors, &saveFileSelecterInfo, NULL, NULL},
	{ 2, saveFileSelectors, &saveFileSelecterInfo, setPickup, "*.snd"},
	{ EOF, NULL, NULL, NULL, NULL}
};

/***************************************************************************
 *	ɤ߹ߥ˥塼ܤؤݥloadSortSelectors
 *		
 *		ա̣
 *		
 *		 0ܣ
 *		
 *		 1ܣ
 *		
 *		 2ܣ
 *		
 *		 3ܣ
 *		
 *		 4ܣ
 *		
 *		 5      
 *		
 ***************************************************************************/
struct menu_data *saveSortSelectors[] = {
	&saveMenuInfo[5], &saveMenuInfo[6], &saveMenuInfo[7],
	&saveMenuInfo[8], &saveMenuInfo[9], NULL
};

/***************************************************************************
 *	񤭹ߥ˥塼ե륽ȾsaveSortPaneInfo
 *		
 *		ؿա̣
 *		
 *		 0setSortFunc 򨢥Ȥʤ
 *		
 *		 1setSortFunc ASCII ȡ
 *		
 *		 2setSortFunc Suffixȡ
 *		
 *		 3setSortFunc եȡ
 *		
 *		 4setSortFunc 򨢥ե륵ȡ
 *		
 *		EOF 
 *		
 ***************************************************************************/
selectorPanes saveSortPaneInfo[] = {
	{ 0, saveSortSelectors, &saveFileSelecterInfo, setSortFunc, NULL}, 
	{ 1, saveSortSelectors, &saveFileSelecterInfo, setSortFunc, ascii_comp},
	{ 2, saveSortSelectors, &saveFileSelecterInfo, setSortFunc, suffix_comp}, 
	{ 3, saveSortSelectors, &saveFileSelecterInfo, setSortFunc, date_comp},
	{ 4, saveSortSelectors, &saveFileSelecterInfo, setSortFunc, size_comp},
	{ EOF, NULL, NULL, NULL, NULL}
};

int (*compire_func)(const void *, const void *) = NULL;

/***************************************************************************
 *	checkSndHeader: 
 *	
 *		int checkSndHeader(const struct snd_head *head, FILE *fp);
 *	
 *		const struct snd_head *head;
 *		FILE *fp;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
int checkSndHeader(const struct snd_head *head, FILE *fp)
{
	int result = 0;

	if(head != NULL) {
		if(head->resv1 != 0 || head ->resv2 != 0 || head->rate > 2042) {
			result = EOF;
		}
		if(fp != NULL && head->length + sizeof(*head) < ftell(fp)) {
			result = EOF;
		}
	}
	return(result);
}

/***************************************************************************
 *	pcmNaming: ե̾Ƭ֤
 *	
 *		char *pcmNaming(char *filename);
 *	
 *		char *filename;
 *	֤
 *		ե̾Ƭ֤
 ***************************************************************************/
const char *pcmNaming(const char *filename)
{
	int counter;

	counter = strlen(filename);
	while(counter > 0 && *(filename + counter - (counter > 0)) != '/')
		--counter;
	return(filename + counter);
}

/***************************************************************************
 *	pcmSaving: УãͺؿXtAppAddInput() Хåؿ
 *	
 *		void pcmSaving(XtPointer client_data, int *source, XtInputId *id);
 *	
 *		XtPointer client_data;	ѥǡ¤Τؤݥ
 *		int *source;			/dev/pcmɤΥե뵭һ
 *		XtInputId *id;			XtAppAddInput() Σɣ
 ***************************************************************************/
void pcmSaving(XtPointer client_data, int *source, XtInputId *id)
{
	size_t nbytes, saveCounter;
	WaveOrder **savingMemory = client_data;

#ifdef	DEBUG
	printf("Now saving!!\n");	fflush(stdout);
#endif	/*DEBUG*/
	if((savingMemory != NULL)?(*savingMemory != NULL):(0)) {
#ifdef	DEBUG
		printf("Now saving I/O !!\n");	fflush(stdout);
#endif	/*DEBUG*/
		/*while((*savingMemory)->next_ptr != NULL)*/ {
			saveCounter = fileOperation->current_size;
			/*while(saveCounter < (*savingMemory)->encoding_size)*/ {
#ifdef	SYSTEM_CALL
				nbytes = write(*source, (*savingMemory)->pcm_wave + saveCounter, 
								(*savingMemory)->encoding_size - saveCounter);
#else
				nbytes = fwrite((*savingMemory)->pcm_wave, 1, 
							(*savingMemory)->encoding_size - saveCounter, fileOperation->stream);
#endif	/*SYSTEM_CALL*/
				if(nbytes > 0) {
					saveCounter += nbytes;
				} else {
					perror("pcmSaving");
					/*break;*/
				}
			}
			fileOperation->current_size = saveCounter;
			if(saveCounter >= (*savingMemory)->encoding_size) {
				if((*savingMemory)->next_ptr != NULL) {
					*savingMemory = (*savingMemory)->next_ptr;
					fileOperation->current_size = 0;
				} else {
					XtRemoveInput(fileOperation->id);
					fclose(fileOperation->stream);
				}
			}
		}
	}
}

/***************************************************************************
 *	savingStart: ϴؿ
 *	
 *		void savingStart(Widget w);
 *	
 *		Widget w;				ץꥱ󡦥ƥȼ
 ***************************************************************************/
void savingStart(Widget w, const char *filename)
{
	String saveNameAlloc_ptr;
	static WaveOrder *savingMemory;
	extern WavesLink *currentWaves;
	
#ifdef	DEBUG
	printf("savingStart!!\n");
#endif	/*DEBUG*/
	savingOperation.wave = currentWaves;
	savingMemory = savingOperation.wave->wave;
	savingOperation.stream = fopen(filename, "w");
	if(savingOperation.stream != NULL) {
		savingOperation.current_size = 0;
		memcpy(savingOperation.wave->header.name, pcmNaming(filename), 
						sizeof(savingOperation.wave->header.name));
		saveNameAlloc_ptr = NewSndNameAlloc(&savingOperation.wave->header);
		if(saveNameAlloc_ptr != NULL) {
			free(savingOperation.wave->wave_name);
			savingOperation.wave->wave_name = saveNameAlloc_ptr;
		}
		WaveRename(currentWaves);
		makeMemoryList();
		fwrite(&savingOperation.wave->header, 
			sizeof(savingOperation.wave->header), 1, savingOperation.stream);
		fileOperation = &savingOperation;
		savingOperation.startOperation = NULL;
		savingOperation.finishedOperation = NULL;
		savingOperation.id = XtAppAddInput(XtWidgetToApplicationContext(w), 
									fileno(savingOperation.stream), 
									(XtPointer)XtInputWriteMask, 
									pcmSaving, &savingMemory);
#ifdef	DEBUG
		printf("saving start!! file open suceeded.\n");	fflush(stdout);
#endif	/*DEBUG*/
	} else {
#ifdef	DEBUG
		printf("savingStart!! FileName = \"%s\"is filed.", filename);
		perror("savingStart!!");
#endif	/*DEBUG*/
	}
#ifdef	DEBUG
	printf("savingStart!! End\n");
#endif	/*DEBUG*/
}

/***************************************************************************
 *	pcmSave: SAVE Ρ*.SND¸Хåؿ
 *	
 *		void pcmSave(Widget w, 
 *						XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 ***************************************************************************/
void pcmSave(Widget w, XtPointer client_data, XtPointer call_data)
{
	String filename;
	PopdownInfo *popdownData = (PopdownInfo*)client_data;

	/*filename = XawDialogGetValueString((Widget)popdownData->client_data);*/
	XtVaGetValues((Widget)popdownData->client_data, XtNstring, &filename, NULL);
	savingStart(w, filename);
}

#ifdef FINISHED
/***************************************************************************
 *	Playing: ܥplay åȡˤΥХåؿ
 *	
 *		void Playing(Widget w, 
 *						XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 ***************************************************************************/
/*ARGSUSED*/
void Playing(Widget w, XtPointer client_data, XtPointer call_data)
{
	Boolean playFlag, pauseFlag;
	extern WavesLink *memoryListTop;

	XtVaGetValues(w, XtNstate, &playFlag, NULL);
	
	if(playFlag == True) {
		operationEnd();
		playingOperation.stream = NULL;
		fileOperation = &playingOperation;
		playingOperation.wave = WaveListShowCurrent();
		playingOperation.startOperation = playbackStart;
		playingOperation.finishedOperation = NULL;
		XtVaGetValues((Widget)client_data, XtNstate, &pauseFlag, NULL);
		if(pauseFlag == False) {
			 playingOperation.startOperation(w);
		}
	}
}
#endif /*FINISHED*/

/***************************************************************************
 *	pcmLoading: ӣΣĥեɤ߹ߡXtAppAddInput() Хåؿ
 *	
 *		void pcmLoading(XtPointer client_data, int *source, XtInputId *id);
 *	
 *		XtPointer client_data;	Ͽѥǡ¤Τؤݥ
 *		int *source;			/dev/pcmrecɤΥե뵭һ
 *		XtInputId *id;			XtAppAddInput() Σɣ
 ***************************************************************************/
void pcmLoading(XtPointer client_data, int *source, XtInputId *id)
{
	size_t nbytes, recCounter;
	WaveOrder **loadingMemory = client_data;

	if((loadingMemory != NULL)?(*loadingMemory != NULL):(0)) {
		/*printf("Now Loading! Real!!\n");*/
		/*do*/ {
			recCounter = (*loadingMemory)->recording_size;
			while(recCounter < (*loadingMemory)->wave_size) {
				nbytes = fread((*loadingMemory)->pcm_wave, 1,
							(*loadingMemory)->wave_size - recCounter, fileOperation->stream);
				if(nbytes > 0) {
					recCounter += nbytes;
				} else {
					if(ferror(fileOperation->stream)) {
						perror("pcmRecording");
					}
				}
			}
			(*loadingMemory)->recording_size = recCounter;
			(*loadingMemory)->encoding_size = recCounter;
			/*printf("Now Loading! %p -- %d.\n", (*loadingMemory), recCounter);*/
			if(recCounter >= (*loadingMemory)->wave_size || feof(fileOperation->stream)) {
				if((*loadingMemory)->next_ptr != NULL) {
					*loadingMemory = (*loadingMemory)->next_ptr;
				} else {
					XtRemoveInput(fileOperation->id);
					fclose(fileOperation->stream);
					WaveGraph(loadingOperation.wave);
				}
			}
		} /*while((*loadingMemory)->next_ptr != NULL);*/
	}
}

/***************************************************************************
 *	NewSndName: ȷǡΥꥹȤؤɽѤʸ
 *	
 *		char *NewSndName(struct snd_head *sndFileHeader);
 *	
 *		struct snd_head *sndFileHeader;	ȷǡΥإå
 *	֤
 *		NULL		­
 *		NULLʳ	ȷǡΥꥹȤϿʸ
 *	
 *		
 ***************************************************************************/
String NewSndNameAlloc(struct snd_head *sndFileHeader)
{
	String newWaveName;
	static char sting_buffer[40];

	sprintf(sting_buffer, "%.8s"" ""%d:%02d.%02d -- %d:%02d.%02d", 
		sndFileHeader->name, 
		0,0,0, sndFileHeader->length / MinuteSize, 
		(sndFileHeader->length / SecondSize) % 60, 
		(sndFileHeader->length / CentiSecSize) % 100);
	newWaveName = (String)malloc(strlen(sting_buffer) + 1);
	if(newWaveName != NULL) {
		strcpy(newWaveName, sting_buffer);
	}
	return(newWaveName);
}

/***************************************************************************
 *	loadingStart: Ͽϴؿ
 *	
 *		void loadingStart(Widget w);
 *	
 *		Widget w;				ץꥱ󡦥ƥȼ
 ***************************************************************************/

void loadingStart(Widget w, const char *filename)
{
	int status; 
	String loadNameAlloc_ptr;
	struct snd_head sndFileHeader;
	WavesLink *allocTimes;
	WavesLink *LinkedWaveAlloc(size_t size);

	loadingOperation.stream = fopen(filename, "r");
	if(loadingOperation.stream != NULL) {
		/* printf("loading start!!\n");	fflush(stdout); */
		status = fread(&sndFileHeader, 
						sizeof(sndFileHeader), 1, loadingOperation.stream);
		if(status > 0 && checkSndHeader(&sndFileHeader, 
										loadingOperation.stream) == EOF) {
			/* إåΥǡ۾ */
			fclose(loadingOperation.stream);
			return;
		}
#ifdef	SELECTION_DEBUG
		printf("Wave Size %d bytes\n", sndFileHeader.length);
#endif	/*SELECTION_DEBUG*/
		allocTimes = LinkedWaveAlloc(sndFileHeader.length);
		allocTimes->header = sndFileHeader;
		loadNameAlloc_ptr = NewSndNameAlloc(&sndFileHeader);
		if(loadNameAlloc_ptr != NULL) {
			free(allocTimes->wave_name);
			allocTimes->wave_name = loadNameAlloc_ptr;
		}
		makeMemoryList();
		loadingOperation.wave = allocTimes;
		loadingOperation.current_wave = loadingOperation.wave->wave;
		loadingOperation.id = 
				XtAppAddInput(XtWidgetToApplicationContext(w), 
							fileno(loadingOperation.stream), 
							(XtPointer)XtInputReadMask, 
							pcmLoading, &loadingOperation.current_wave);
		fileOperation = &loadingOperation;
	}
}

/***************************************************************************
 *	pcmLoad: LOAD Ρ*.SNDɤ߹ߥХåؿ
 *	
 *		void pcmSave(Widget w, 
 *						XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 ***************************************************************************/
void pcmLoad(Widget w, XtPointer client_data, XtPointer call_data)
{
	String filename;
	PopdownInfo *popdownData = (PopdownInfo*)client_data;

	/*filename = XawDialogGetValueString((Widget)popdownData->client_data);*/
	XtVaGetValues((Widget)popdownData->client_data, XtNstring, &filename, NULL);
	loadingStart(w, filename);
}

/***************************************************************************
 *	PopupDialog: ǥǡϿѤΥΥݥåץå
 *	
 *		void PopupDialog(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;	
 *		XtPointer client_data;	
 *		XtPointer call_data;	
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void PopupDialog(Widget w, XtPointer client_data, XtPointer call_data)
{
	PopdownInfo *popdownData = (PopdownInfo*)client_data;
	Position x, y;
	Dimension width, height;

	/*********************************************************
	 *	ݥåץåפεˤʤääȤ礭
	 *********************************************************/
	XtVaGetValues(popdownData->popupWidget, 
			XtNwidth, &width,
			XtNheight, &height,
			NULL);
	
	/***********************************
	 *	Root Window κɸϤѴ
	 ***********************************/
	XtTranslateCoords(popdownData->popupWidget,		/* Widget */
			(Position) width/2,						/* x */
			(Position) height/2,					/* y */
			&x, &y);						/* coords on root window */

	/*******************************************************************
	 *	ݥåץåץΰ֤ꤹʤޤвƤʤ
	 *******************************************************************/
	XtVaSetValues(popdownData->popdownShell, 
			XtNx, x,
			XtNy, y,
			NULL);

	XtPopup(popdownData->popdownShell, XtGrabExclusive);
}

/***************************************************************************
 *	DialogDone: ǥǡϿѤΥΥݥåץ
 *	
 *		void DialogDone(Widget w, 
 *								XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;	
 *		XtPointer client_data;	
 *		XtPointer call_data;	
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void PcmDialogDone(Widget w, XtPointer client_data, XtPointer call_data)
{
	String string;
	PopdownInfo *popdownData = (PopdownInfo*)client_data;

	XtPopdown(popdownData->popdownShell);
	XtSetSensitive(popdownData->popupWidget, TRUE);
	/*****************************************************
	 *	åȤϤʸ
	 *****************************************************/
	/*string = XawDialogGetValueString((Widget)popdownData->client_data);*/
	XtVaGetValues((Widget)popdownData->client_data, XtNstring, &string, NULL);
	/* printf("Dialog = \"%s\"\n", string); */
}

/***************************************************************************
 *	load_chd: 
 *	
 *		void load_chd(Widget w, 
 *								XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;	
 *		XtPointer client_data;	
 *		XtPointer call_data;	
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void load_chd(Widget w, XtPointer client_data, XtPointer call_data)
{
	chdir(loadFileSelecterInfo.searchingPath);
}

/***************************************************************************
 *	save_chd: 
 *	
 *		void save_chd(Widget w, 
 *								XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;	
 *		XtPointer client_data;	
 *		XtPointer call_data;	
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void save_chd(Widget w, XtPointer client_data, XtPointer call_data)
{
	chdir(saveFileSelecterInfo.searchingPath);
}

/***************************************************************************
 *	preFileMenu: ե롦˥塼ġԲɽ
 *	
 *		static void preFileMenu(Widget w, 
 *								XtPointer client_data, XtPointer garbage);
 *	
 *		Widget w;				å
 *		XtPointer client_data;	˥塼ֹ
 *		XtPointer garbage;		̤
 *	
 *		
 ***************************************************************************/
/* ARGSUSED */
void preFileMenu(Widget w, XtPointer client_data, XtPointer garbage)
{
	Boolean sensitive;
	extern Widget pcmWave;
	struct menuData *menuInfo = (struct menuData*) client_data;
	extern WavesLink *currentWaves;

	sensitive = XawIsWaveChartSelecting(pcmWave);

	XtSetSensitive((menuInfo->info+2)->myWidget, (currentWaves != NULL));
}

/***************************************************************************
 *	paneMarkClaer: 쥯˥塼ܤΥޡ򥯥ꥢ
 *	
 *		void paneMarkClaer(struct menuData *menuInfo);
 *	
 *		struct menuData *menuInfo;
 *	
 *		
 ***************************************************************************/
int paneMarkClaer(struct menuData *menuInfo)
{
	int i;
	int numOfMenuItems;

	numOfMenuItems = menuInfo->num;

	for (i = 0; i < numOfMenuItems; i++) {
		switch(menuInfo->info[i].type) {
		case TypeSmeBSB:
			XtVaSetValues(menuInfo->info[i].myWidget, 
											XtNleftBitmap, None, NULL);
			break;
		default:
			break;
		}
	}
}

/***************************************************************************
 *	paneTypeCount: ˥塼
 *	
 *		int paneTypeCount(struct menu_data *menuInfo);
 *	
 *		struct menu_data **menuInfo;
 *	
 *		
 ***************************************************************************/
int paneTypeCount(const struct menu_data *menuInfo, int type)
{
	int counter;

	counter = 0;
	while((menuInfo + counter)->type == type)
		++counter;
	return(counter);
}

/***************************************************************************
 *	paneSequenceTypeCount: ˥塼
 *	
 *		int paneSequenceTypeCount(struct menu_data *menuInfo);
 *	
 *		struct menu_data **menuInfo;
 *	
 *		
 ***************************************************************************/
int paneSequenceTypeCount(const struct menu_data *menuInfo, int type)
{
	int counter = 0;

	while(menuInfo->type != EOF) {
		while(menuInfo->type != type && menuInfo->type != EOF)
			++menuInfo;

		if(menuInfo->type == type) {
			while(menuInfo->type == type)
				++menuInfo;
			++counter;
		}
	}
	return(counter);
}

/***************************************************************************
 *	menuSelectorPanes: ˥塼ʬΥޡѹ
 *	
 *		void menuSelectorPanes(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;	
 *		XtPointer client_data;	
 *		XtPointer call_data;	
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void menuSelectorPanes(Widget w, XtPointer client_data, XtPointer call_data)
{
	int counter;
	selectorPanes *info = (selectorPanes*) client_data;
	extern Pixmap mark;

	if(info->option != NULL)
		info->option(w, client_data,  call_data);
	
	for(counter = 0;*(info->panesInfo + counter) != NULL;++counter) {
		if(counter == info->paneNo) {
			XtVaSetValues((*(info->panesInfo + counter))->myWidget, 
												XtNleftBitmap, mark, NULL);
		} else {
			XtVaSetValues((*(info->panesInfo + counter))->myWidget, 
												XtNleftBitmap, None, NULL);
		}
	}
	remakeFilePickup(info->fileSelecterInfo);
}

/***************************************************************************
 *	setPickup: ե򤷤ޤ
 *	
 *		void setPickup(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;	
 *		XtPointer client_data;	
 *		XtPointer call_data;	
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void setPickup(Widget w, XtPointer client_data, XtPointer call_data)
{
	selectorPanes *info = (selectorPanes*) client_data;

	if(info->client_data != NULL)
		filePickup = (char*)info->client_data;
	else
		filePickup = NULL;
}

/***************************************************************************
 *	setSortFunc: ե򤷤ޤ
 *	
 *		void setSortFunc(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;	
 *		XtPointer client_data;	
 *		XtPointer call_data;	
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void setSortFunc(Widget w, XtPointer client_data, XtPointer call_data)
{
	selectorPanes *info = (selectorPanes*) client_data;

	if(info->client_data != NULL)
		sort_comp = (int (*)(const void *, const void *))info->client_data;
	else
		sort_comp = NULL;
}

/***************************************************************************
 *	selectorPane: 򤵤줿˥塼ܤޡ
 *	
 *		void selectorPane(Widget w, 
 *								XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;	
 *		XtPointer client_data;	
 *		XtPointer call_data;	
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void selectorPane(Widget w, XtPointer client_data, XtPointer call_data)
{
	struct menu_data *info = (struct menu_data*) client_data;
	extern Pixmap mark;

	XtVaSetValues(info->myWidget, XtNleftBitmap, mark, NULL);
}

#ifdef	OPTION_DEBUG
/***************************************************************************
 *	: 
 *	
 *		void (Widget w, 
 *								XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;	
 *		XtPointer client_data;	
 *		XtPointer call_data;	
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void (Widget w, XtPointer client_data, XtPointer call_data)
{
}
#endif	/*OPTION_DEBUG*/

/***************************************************************************
 *	loadDialogInit: ǥǡϿѤΥޤॷ
 *	
 *		Widget loadDialogInit(Widget parent, Widget popupButton);
 *	
 *		Widget parent;		ƥå
 *	
 *		
 ***************************************************************************/
Widget loadDialogInit(Widget parent, Widget popupButton)
{
	Widget pcmLoadDialogDone, pcmLoadCancel, pcmLoadFilename;
	Widget pcmLoadFilelabel, pcmLoadDirlabel;
	Widget pcmLoadArea, pcmLoadMenuArea;
	static PopdownInfo loadInfo;

	pLoadShell = XtCreatePopupShell(
			"pLoadShell",
			transientShellWidgetClass,
			parent,
			NULL,
			0
			);

	pcmLoadArea = XtVaCreateManagedWidget(
			"pcmLoadArea", 				/* arbitrary widget name */
			panedWidgetClass,		/* widget class from Form.h */
			pLoadShell,	 			/* parent widget */
			NULL);					/* tarminate varargs list */

	pcmLoadMenuArea = XtVaCreateManagedWidget(
			"pcmLoadMenuArea", 			/* arbitrary widget name */
			boxWidgetClass,			/* widget class from Form.h */
			pcmLoadArea,	 			/* parent widget */
			NULL);					/* tarminate varargs list */

	makeMenus(pcmLoadMenuArea, &loadMenus);
	paneMarkClaer(&loadMenus);
	XtAddCallback((loadMenus.info+1)->myWidget, 
				XtNcallback, menuSelectorPanes, &loadPickupPaneInfo[0]);
	XtAddCallback((loadMenus.info+2)->myWidget, 
				XtNcallback, menuSelectorPanes, &loadPickupPaneInfo[1]);
	XtAddCallback((loadMenus.info+3)->myWidget, 
				XtNcallback, menuSelectorPanes, &loadPickupPaneInfo[2]);
	selectorPane((loadMenus.info+1)->myWidget, loadMenus.info+1, NULL);

	XtAddCallback((loadMenus.info+5)->myWidget, 
				XtNcallback, menuSelectorPanes, &loadSortPaneInfo[0]);
	XtAddCallback((loadMenus.info+6)->myWidget, 
				XtNcallback, menuSelectorPanes, &loadSortPaneInfo[1]);
	XtAddCallback((loadMenus.info+7)->myWidget, 
				XtNcallback, menuSelectorPanes, &loadSortPaneInfo[2]);
	XtAddCallback((loadMenus.info+8)->myWidget, 
				XtNcallback, menuSelectorPanes, &loadSortPaneInfo[3]);
	XtAddCallback((loadMenus.info+9)->myWidget, 
				XtNcallback, menuSelectorPanes, &loadSortPaneInfo[4]);
	selectorPane((loadMenus.info+6)->myWidget, loadMenus.info+6, NULL);

	pcmLoadDialog = XtCreateManagedWidget(
			"pcmLoadDialog", 				/* widget name   */
			formWidgetClass, 				/* widget class */
			pcmLoadArea, 					/* parent widget*/
			NULL,							/* argument list*/
			0 								/* arglist size */
			);

	pcmLoadFilelabel = XtVaCreateManagedWidget(
			"pcmLoadFilelabel", 			/* widget name   */
			labelWidgetClass, 				/* widget class */
			pcmLoadDialog, 					/* parent widget */
			XtNlabel, "File:",
			NULL 							/* argument list */
			);

	pcmLoadDirlabel = XtVaCreateManagedWidget(
			"pcmLoadDirlabel", 				/* widget name   */
			labelWidgetClass, 				/* widget class */
			pcmLoadDialog, 					/* parent widget */
			XtNlabel, "Dir: ",
			NULL 							/* argument list */
			);

	loadFileSelecterInfo.dirWidget = 
		XtVaCreateManagedWidget(
			"pcmLoadDir", 					/* widget name   */
			labelWidgetClass, 				/* widget class */
			pcmLoadDialog, 					/* parent widget */
			NULL 							/* argument list */
			);

	loadFileSelecterInfo.fileWidget = 
	pcmLoadFilename = XtVaCreateManagedWidget(
			"pcmLoadFilename", 				/* widget name   */
			asciiTextWidgetClass, 			/* widget class */
			pcmLoadDialog, 					/* parent widget */
			XtNeditType, XawtextEdit,
			XtNtype,	XawAsciiString,	
			NULL 							/* argument list */
			);

	pcmLoadView = XtVaCreateManagedWidget(
			"pcmLoadView", 					/* widget name   */
			viewportWidgetClass, 			/* widget class */
			pcmLoadDialog,	 				/* parent widget */
			XtNallowVert, TRUE, 			/*  */
			NULL 							/* argument list */
			);
	
	loadFileSelecterInfo.listWidget = 
		XtVaCreateManagedWidget(
			"pcmLoadList", 					/* widget name   */
			listWidgetClass, 				/* widget class */
			pcmLoadView, 					/* parent widget */
			NULL 							/* argument list */
			);

	pcmLoadDialogDone = XtCreateManagedWidget(
			"pcmLoadDialogDone", 			/* widget name   */
			commandWidgetClass, 			/* widget class */
			pcmLoadDialog, 					/* parent widget*/
			NULL, 							/* argument list*/
			0								/* arglist size */
			);

	pcmLoadCancel = XtCreateManagedWidget(
			"pcmLoadCancel", 				/* widget name   */
			commandWidgetClass, 			/* widget class */
			pcmLoadDialog, 					/* parent widget*/
			NULL, 							/* argument list*/
			0								/* arglist size */
			);

	loadFileSelecterInfo.searchingPath = getcwd(NULL, 0);
	remakeFileSelector(&loadFileSelecterInfo);
	loadInfo.popupWidget  = popupButton;
	loadInfo.popdownShell = pLoadShell;
	loadInfo.client_data  = (XtPointer)pcmLoadFilename;
	XtAddCallback(loadFileSelecterInfo.listWidget, XtNcallback, 
					 fileListSelect, &loadFileSelecterInfo);
	XtAddCallback(pcmLoadDialogDone, 
				XtNcallback, PcmDialogDone, &loadInfo);
	XtAddCallback(pcmLoadDialogDone, 
				XtNcallback, pcmLoad, &loadInfo);
	XtAddCallback(popupButton, 
						XtNcallback, PopupDialog, &loadInfo);
	XtAddCallback(pcmLoadCancel, 
				XtNcallback, PcmDialogDone, &loadInfo);
	return(pLoadShell);
}

/***************************************************************************
 *	saveDialogInit: ǥǡϿѤΥޤॷ
 *	
 *		Widget saveDialogInit(Widget parent, Widget popupButton);
 *	
 *		Widget parent;		ƥå
 *	
 *		
 ***************************************************************************/
Widget saveDialogInit(Widget parent, Widget popupButton)
{
	Widget pcmSaveDialogDone, pcmSaveCancel, pcmSaveFilename;
	Widget pcmSaveFilelabel, pcmSaveDirlabel;
	Widget pcmSaveArea, pcmSaveMenuArea;
	static PopdownInfo saveInfo;

	pSaveShell = XtCreatePopupShell(
			"pSaveShell",
			transientShellWidgetClass,
			parent,
			NULL,
			0
			);

	pcmSaveArea = XtVaCreateManagedWidget(
			"pcmSaveArea", 				/* arbitrary widget name */
			panedWidgetClass,			/* widget class from Form.h */
			pSaveShell,	 				/* parent widget */
			NULL);						/* tarminate varargs list */

	pcmSaveMenuArea = XtVaCreateManagedWidget(
			"pcmSaveMenuArea", 			/* arbitrary widget name */
			boxWidgetClass,				/* widget class from Form.h */
			pcmSaveArea,	 			/* parent widget */
			NULL);						/* tarminate varargs list */

	makeMenus(pcmSaveMenuArea, &saveMenus);
	paneMarkClaer(&saveMenus);
	XtAddCallback((saveMenus.info+1)->myWidget, 
				XtNcallback, menuSelectorPanes, &savePickupPaneInfo[0]);
	XtAddCallback((saveMenus.info+2)->myWidget, 
				XtNcallback, menuSelectorPanes, &savePickupPaneInfo[1]);
	XtAddCallback((saveMenus.info+3)->myWidget, 
				XtNcallback, menuSelectorPanes, &savePickupPaneInfo[2]);
	selectorPane((saveMenus.info+1)->myWidget, saveMenus.info+1, NULL);

	XtAddCallback((saveMenus.info+5)->myWidget, 
				XtNcallback, menuSelectorPanes, &saveSortPaneInfo[0]);
	XtAddCallback((saveMenus.info+6)->myWidget, 
				XtNcallback, menuSelectorPanes, &saveSortPaneInfo[1]);
	XtAddCallback((saveMenus.info+7)->myWidget, 
				XtNcallback, menuSelectorPanes, &saveSortPaneInfo[2]);
	XtAddCallback((saveMenus.info+8)->myWidget, 
				XtNcallback, menuSelectorPanes, &saveSortPaneInfo[3]);
	XtAddCallback((saveMenus.info+9)->myWidget, 
				XtNcallback, menuSelectorPanes, &saveSortPaneInfo[4]);
	selectorPane((saveMenus.info+6)->myWidget, saveMenus.info+6, NULL);
	paneSequenceTypeCount(saveMenus.info, TypeSmeBSB);

	pcmSaveDialog = XtCreateManagedWidget(
			"pcmSaveDialog", 				/* widget name   */
			formWidgetClass, 				/* widget class */
			pcmSaveArea, 					/* parent widget*/
			NULL,							/* argument list*/
			0 								/* arglist size */
			);

	pcmSaveFilelabel = XtVaCreateManagedWidget(
			"pcmSaveFilelabel", 			/* widget name   */
			labelWidgetClass, 				/* widget class */
			pcmSaveDialog, 					/* parent widget */
			XtNlabel, "File:",
			NULL 							/* argument list */
			);

	pcmSaveDirlabel = XtVaCreateManagedWidget(
			"pcmSaveDirlabel", 				/* widget name   */
			labelWidgetClass, 				/* widget class */
			pcmSaveDialog, 					/* parent widget */
			XtNlabel, "Dir: ",
			NULL 							/* argument list */
			);

	saveFileSelecterInfo.dirWidget = 
		XtVaCreateManagedWidget(
			"pcmSaveDir", 					/* widget name   */
			labelWidgetClass, 				/* widget class */
			pcmSaveDialog, 					/* parent widget */
			NULL 							/* argument list */
			);

	saveFileSelecterInfo.fileWidget = 
	pcmSaveFilename = XtVaCreateManagedWidget(
			"pcmSaveFilename", 				/* widget name   */
			asciiTextWidgetClass, 			/* widget class */
			pcmSaveDialog, 					/* parent widget */
			XtNeditType, XawtextEdit,
			XtNtype,	XawAsciiString,	
			NULL 							/* argument list */
			);

	pcmSaveView = XtVaCreateManagedWidget(
			"pcmSaveView", 					/* widget name   */
			viewportWidgetClass, 			/* widget class */
			pcmSaveDialog,	 				/* parent widget */
			XtNallowVert, TRUE, 			/*  */
			NULL 							/* argument list */
			);
	
	saveFileSelecterInfo.listWidget = 
		XtVaCreateManagedWidget(
			"pcmSaveList", 					/* widget name   */
			listWidgetClass, 				/* widget class */
			pcmSaveView, 					/* parent widget */
			NULL 							/* argument list */
			);

	pcmSaveDialogDone = XtCreateManagedWidget(
			"pcmSaveDialogDone", 			/* widget name   */
			commandWidgetClass, 			/* widget class */
			pcmSaveDialog, 					/* parent widget*/
			NULL, 							/* argument list*/
			0								/* arglist size */
			);

	pcmSaveCancel = XtCreateManagedWidget(
			"pcmSaveCancel", 				/* widget name   */
			commandWidgetClass, 			/* widget class */
			pcmSaveDialog, 					/* parent widget*/
			NULL, 							/* argument list*/
			0								/* arglist size */
			);

	saveFileSelecterInfo.searchingPath = getcwd(NULL, 0);
	remakeFileSelector(&saveFileSelecterInfo);
	saveInfo.popupWidget  = popupButton;
	saveInfo.popdownShell = pSaveShell;
	saveInfo.client_data  = (XtPointer)pcmSaveFilename;
	XtAddCallback(saveFileSelecterInfo.listWidget, XtNcallback, 
					 fileListSelect, &saveFileSelecterInfo);
	XtAddCallback(pcmSaveDialogDone, 
				XtNcallback, PcmDialogDone, &saveInfo);
	XtAddCallback(pcmSaveDialogDone, 
				XtNcallback, pcmSave, &saveInfo);
	XtAddCallback(popupButton, 
						XtNcallback, PopupDialog, &saveInfo);
	XtAddCallback(pcmSaveCancel, 
				XtNcallback, PcmDialogDone, &saveInfo);
	return(pSaveShell);
}

