/****************************************************************************
 *	waves.c: ȷϢ
 *
 *			Date. 1994/09/14 -- 1995/01/29
 *				Programed by Nobuyuki Maruichi
 *				Adviced by S.Kouno
 *
 *	Note.
 *			SHIFT JIS Kanji Code / JIS X0208 1983
 *			Tab Size 4 / Shift Width = 4
 *	from
 *		mixcd.c(maxcd.c)
 *		PCM player T-E-S-T program  Copyright (C) 1993 S.Kouno
 *		PCM recording T-E-S-T program  Copyright (C) 1993 S.Kouno
 ***************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <fcntl.h>

/****************************************************
 *	X Toolkit/Athena Widget Υ󥯥롼ɡե
 ****************************************************/
#include <X11/Intrinsic.h>	/* Intrinsics Definitions */
#include <X11/StringDefs.h>	/* Standard Name-String definitions */
#include <X11/Core.h>
#include <X11/Shell.h>

#include <X11/Xatom.h>
#include <X11/Xmu/Atoms.h>

#include "WaveChart.h"

/***********************************************
 *	PCM Recorder/Player ѤΥإåե
 ***********************************************/
#include "snd.h"
#include "ggxsnd.h"

/***************************************************************************
 *	Хѿ
 *		ץ󥰥ط
 *			MinuteSize: 	ʬ֤ΥХȿ
 *			SecondSize: 	ô֤ΥХȿ
 *			CentiSecSize: 	ô֤ΥХȿ
 *			currentSize: 	˳ȤȷΥХȿ
 *			unitSize: 		γñ
 *			deltaSize: 		Ͽ֤ѹñ
 *			recTimeResizeCounter: 	Ͽ֤ѹѤΥ
 *		ȷط
 *			memoryListTop:	ꡦꥹȤƬ
 ***************************************************************************/
extern long MinuteSize;
extern long SecondSize;
extern long CentiSecSize;
extern long currentSize;
extern long unitSize;
extern long deltaSize;
extern int recTimeResizeCounter;
WavesLink *currentWaves = NULL;

extern Atom WaveAtom;
typedef struct _WaveSelectionInfo {
	Atom type;						/* 쥯ͤɽ򼨤ޤ */
	XtPointer value;				/* 쥯ͤγǼ򼨤 */
	unsigned long length;			/* 쥯ͤǤθĿ */
	int format;						/* 쥯ͤǤ礭 */
} WaveSelectionInfo;
WaveSelectionInfo PasteInfo = {
	0, NULL, 0, 8
};

static void requestor_callback(Widget w, XtPointer client_data, 
				Atom *selection, Atom *type, 
				XtPointer value, unsigned long *length, int *format);
static void (*OnceAction_ptr)(Widget w, XEvent *event, 
							String *params, Cardinal *num_params);
void SelectCopyOnce(Widget w, XEvent *event, 
							String *params, Cardinal *num_params);
void SelectPasteOnce(Widget w, XEvent *event, 
							String *params, Cardinal *num_params);
void SelectUnselectOnce(Widget w, XEvent *event, 
							String *params, Cardinal *num_params);

static Boolean convert_proc(Widget w, Atom *selection, Atom *target,
				Atom *type_return, XtPointer *value_return, 
				unsigned long *length_return, int *format_return);
static void requestor_callback(Widget w, XtPointer client_data, 
				Atom *selection, Atom *type, 
				XtPointer value, unsigned long *length, int *format);

/***************************************************************************
 *	WaveUnitAlloc: ȷǡδñʬΥƤ
 *	
 *		static WaveOrder *WaveUnitAlloc(size_t size);
 *	
 *		size_t size;	ƤȷΥХȿ̾ϴñ̰ʲ
 *	֤
 *		NULL		­
 *		NULLʳ	WaveOrderι¤ΤؤΥݥ
 *	
 *		ȷǡδñʬΥƤ롣
 *		δؿϡñ̰ʲΥƤ뤿ΤΤʤΤǡ
 *		δؿľܸƤӽФơ礭ʥƤʤ褦ˤ롣
 *	Ȼ
 *		
 ***************************************************************************/
static WaveOrder *WaveUnitAlloc(size_t size)
{
	WaveOrder *alloc_ptr;

	alloc_ptr = (WaveOrder*)malloc(sizeof(*alloc_ptr));
	if(alloc_ptr != NULL) {
		if(size > 0) {
			alloc_ptr->pcm_wave = (char*)malloc(size);
		} else {
			alloc_ptr->pcm_wave = NULL;
		}
		if(alloc_ptr->pcm_wave != NULL) {
			alloc_ptr->encoding_size = 0;
			alloc_ptr->recording_size = 0;
			alloc_ptr->wave_size = size;
			alloc_ptr->prev_ptr = NULL;
			alloc_ptr->next_ptr = NULL;
		} else {
			free(alloc_ptr);
			alloc_ptr = NULL;
		}
	}
	return(alloc_ptr);
}

/***************************************************************************
 *	WaveMemoryAlloc: ȷǡΥΥ󥯥ȥꥹȤƤ
 *	
 *		WaveOrder *WaveMemoryAlloc(size_t size);
 *	
 *		size_t size;	ƤȷΥХȿ
 *	֤
 *		NULL		­
 *		NULLʳ	WaveOrderι¤ΤؤΥݥ
 *	
 *		WaveOrder Υ󥯥ȥꥹȷǡΥƤ롣
 ***************************************************************************/
WaveOrder *WaveMemoryAlloc(size_t size)
{
	size_t alloc_size;
	WaveOrder *alloc_ptr = NULL;
	extern long unitSize;

	alloc_size = ((size > unitSize)?(unitSize):(size));
	if(size > 0) {
		alloc_ptr = WaveUnitAlloc(alloc_size);
		if(alloc_ptr != NULL && size > unitSize) {
			if(size - alloc_size > 0) {
				alloc_ptr->next_ptr = WaveMemoryAlloc(size - alloc_size);
				if(alloc_ptr->next_ptr != NULL) {
					alloc_ptr->next_ptr->prev_ptr = alloc_ptr;
				} else {
					free(alloc_ptr);
					alloc_ptr = NULL;
				}
			}
		}
	}
	return(alloc_ptr);
}

/***************************************************************************
 *	AllocTimes: ȷǡΥƤ
 *	
 *		WavesLink *AllocTimes(size_t size);
 *	
 *		size_t size;	ƤȷΥХȿ
 *	֤
 *		NULL		­
 *		NULLʳ	WavesLinkι¤ΤؤΥݥ
 *	
 *		
 ***************************************************************************/
WavesLink *AllocTimes(size_t size)
{
	char sting_buffer[40];
	WavesLink *alloc_ptr = NULL;

	alloc_ptr = (WavesLink*)malloc(sizeof(*alloc_ptr));

	if(alloc_ptr != NULL) {
		make_sndHeader("Memory", size, &alloc_ptr->header);
		sprintf(sting_buffer, "Memory"" ""%d:%02d.%02d -- %d:%02d.%02d", 
			0,0,0, size / MinuteSize, 
			(size / SecondSize) % 60, (size / CentiSecSize) % 100);
		alloc_ptr->wave_name = (char*)malloc(strlen(sting_buffer) + 1);
		if(alloc_ptr->wave_name != NULL) {
			strcpy(alloc_ptr->wave_name, sting_buffer);
			alloc_ptr->wave = WaveMemoryAlloc(size);
			alloc_ptr->currentPos = 0;
			alloc_ptr->prev_ptr = NULL;
			alloc_ptr->next_ptr = NULL;
			if(alloc_ptr->wave == NULL) {
				free(alloc_ptr->wave_name);
				free(alloc_ptr);
				alloc_ptr = NULL;
			}
		} else {
			free(alloc_ptr);
			alloc_ptr = NULL;
		}
	}
	return(alloc_ptr);
}

/***************************************************************************
 *	WaveRename: ȷǡȷ̾Τ򹹿
 *	
 *		void WaveRename(WavesLink *wave);
 *	
 *		WavesLink *wave;	ȷ
 *	
 *		
 ***************************************************************************/
void WaveRename(WavesLink *wave)
{
	size_t size;
	char sting_buffer[40], *new_name;

	if(wave != NULL) {
		size = wave->header.length = 
					sizeOfWave(currentWaves->wave, getEncodingSizeUnit);
		sprintf(sting_buffer, "%.8s"" ""%d:%02d.%02d -- %d:%02d.%02d", 
				wave->header.name, 0,0,0, size / MinuteSize, 
				(size / SecondSize) % 60, (size / CentiSecSize) % 100);
		new_name = (char*)malloc(strlen(sting_buffer) + 1);
		if(new_name != NULL) {
			free(wave->wave_name);
			wave->wave_name = new_name;
			strcpy(wave->wave_name, sting_buffer);
		}
	}
}

/***************************************************************************
 *	releaseWaveMemory: ȷǡΥΥ󥯥ȥꥹȤ
 *	
 *		WaveOrder *releaseWaveMemory(size_t size);
 *	
 *		WaveOrder *wave;
 *	
 *		WaveOrder Υ󥯥ȥꥹȷǡΥ롣
 ***************************************************************************/
void releaseWaveMemory(WaveOrder *wave)
{
	WaveOrder *next_ptr, *release_ptr;

	if(wave != NULL) {
		for(release_ptr = wave;
					release_ptr != NULL;release_ptr = next_ptr) {
			next_ptr = release_ptr->next_ptr;
			free(release_ptr->pcm_wave);
			free(release_ptr);
		}
	}
}

/***************************************************************************
 *	FreeWaves: ȷǡΥƤ
 *	
 *		void FreeWaves(WavesLink *wave);
 *	
 *		WavesLink *wave;	
 *	
 *		
 ***************************************************************************/
void FreeWaves(WavesLink *wave)
{
	extern WavesLink *memoryListTop;

	if(wave != NULL) {
		if(memoryListTop == wave) {
			/* ȷ꤬ꥹȤƬΤȤ */
			memoryListTop = NULL;	/* ꡾󥯥ȥꥹȤζ򼨤 */
		}
		releaseWaveMemory(wave->wave);
		free(wave->wave_name);
		free(wave);
	}
}

/***************************************************************************
 *	UnlinkWaves: ȷǡΥΥ󥯤򳰤
 *	
 *		void UnlinkWaves(WavesLink *wave);
 *	
 *		WavesLink *wave;	
 *	
 *		
 ***************************************************************************/
void UnlinkWaves(WavesLink *wave)
{
	WavesLink *prev_ptr, *next_ptr;
	
	if(wave != NULL) {
		prev_ptr = wave->prev_ptr;
		next_ptr = wave->next_ptr;
		if(wave->prev_ptr != NULL) {
			/* 󥯤ΤĤʤؤ */
			prev_ptr->next_ptr = next_ptr;
			wave->prev_ptr = NULL;
		}
		if(wave->next_ptr != NULL) {
			/* 󥯤ΤĤʤؤ */
			next_ptr->prev_ptr = prev_ptr;
			wave->next_ptr = NULL;
		}
	}
}

/***************************************************************************
 *	linkLastWave: ꥹȤΰֺǸ򥵡
 *	
 *		WavesLink *linkLastWave(WavesLink *waves);
 *	
 *		WavesLink *waves;
 *	֤
 *		NULL		ꥹȤ NULL
 *		NULLʳ	ꥹȤΰֺǸ
 ***************************************************************************/
/*ARGSUSED*/
WavesLink *linkLastWave(WavesLink *waves)
{
	if(waves != NULL) {
		while(waves->next_ptr != NULL) {
			waves = waves->next_ptr;
		}
	}
	return(waves);
}

/***************************************************************************
 *	lastWaveOrder: ȷǡΥΥ󥯥ȥꥹȤ
 *	
 *		WaveOrder *releaseWaveMemory(size_t size);
 *	
 *		WaveOrder *wave;
 *	
 *		WaveOrder Υ󥯥ȥꥹȷǡΥ롣
 ***************************************************************************/
WaveOrder *lastWaveOrder(WaveOrder *wave)
{
	if(wave != NULL) {
		while(wave->next_ptr != NULL) {
			wave = wave->next_ptr;
		}
	}
	return(wave);
}

/***************************************************************************
 *	ConnectWaveOrder: ȷǡΥ³ޤ
 *	
 *		WaveOrder *ConnectWaveOrder();
 *	
 *		WaveOrder *wave;
 *		WaveOrder *next_wave;
 *	
 *		
 ***************************************************************************/
WaveOrder *ConnectWaveOrder(WaveOrder *wave, WaveOrder *next_wave)
{
	if(wave != NULL) {
		wave->next_ptr = next_wave;
	}
	if(next_wave != NULL) {
		next_wave->prev_ptr = wave;
	}
	return(wave);
}

/***************************************************************************
 *	LinkedWaveAlloc: 󥯤줿ȷǡΥƤ
 *	
 *		WavesLink *LinkedWaveAlloc(size_t size);
 *	
 *		size_t size;	ƤȷΥХȿ
 *	֤
 *		NULL		­
 *		NULLʳ	WavesLinkι¤ΤؤΥݥ
 *	
 *		
 ***************************************************************************/
WavesLink *LinkedWaveAlloc(size_t size)
{
	WavesLink *waveList;
	WavesLink *newWave;
	extern WavesLink *memoryListTop;

	if(memoryListTop != NULL) {
		waveList = linkLastWave(memoryListTop);
		waveList->next_ptr = newWave = AllocTimes(size);
		if(waveList->next_ptr != NULL) {
			waveList->next_ptr->prev_ptr = waveList;
		}
	} else {
		waveList = memoryListTop = newWave = AllocTimes(size);
	}
	return(newWave);
}

/***************************************************************************
 *	getMemorySizeUnit: ȷǡδñΥꥵ
 *	
 *		size_t getMemorySizeUnit(WaveOrder *wave);
 *	
 *		WaveOrder *wave;
 *	֤
 *		ȷǡδñΥꥵ
 *	
 *		
 ***************************************************************************/
size_t getMemorySizeUnit(WaveOrder *wave)
{
	return(wave->wave_size);
}

/***************************************************************************
 *	getEncodingSizeUnit: ȷǡδñѴѤΥ
 *	
 *		size_t getEncodingSizeUnit(WaveOrder *wave);
 *	
 *		WaveOrder *wave;
 *	֤
 *		ȷǡδñѴѤΥ
 *	
 *		
 ***************************************************************************/
size_t getEncodingSizeUnit(WaveOrder *wave)
{
	return(wave->encoding_size);
}

/***************************************************************************
 *	getRecordingSizeUnit: ȷǡδñϿѤΥ
 *	
 *		size_t getRecordingSizeUnit(WaveOrder *wave);
 *	
 *		WaveOrder *wave;
 *	֤
 *		ȷǡδñϿѤΥ
 *	
 *		
 ***************************************************************************/
size_t getRecordingSizeUnit(WaveOrder *wave)
{
	return(wave->recording_size);
}

/***************************************************************************
 *	sizeOfWave: ȷǡΥΥ󥯥ȥꥹȤ
 *	
 *		size_t sizeOfWave(WaveOrder *wave);
 *	
 *		WaveOrder *wave;	ȷǡ
 *		size_t (*getUnitSize)(WaveOrder *wave);
 *							ȷǡδñƼ掠ؿ
 *	֤
 *		ȷǡΥ
 *	
 *		WaveOrder Υ󥯥ȥꥹȷǡΥ롣
 ***************************************************************************/
size_t sizeOfWave(WaveOrder *wave, size_t (*getUnitSize)(WaveOrder *wave))
{
	size_t size;

	for(size = 0;wave != NULL;wave = wave->next_ptr) {
		size += getUnitSize(wave);
	}
	return(size);
}

/***************************************************************************
 *	setRecordingSizes: ȷǡϿѥꥵꤹ
 *	
 *		size_t setRecordingSizes(WaveOrder *wave, 
 *								size_t (*getUnitSize)(WaveOrder *wave));
 *	
 *		WaveOrder *wave;	ȷǡ
 *		size_t (*getUnitSize)(WaveOrder *wave);
 *							ȷǡδñƼ掠ؿ
 *	֤
 *		ȷǡΥ
 *	
 *		WaveOrder Υ󥯥ȥꥹȷǡΥ롣
 ***************************************************************************/
size_t setRecordingSizes(WaveOrder *wave, 
							size_t (*getUnitSize)(WaveOrder *wave))
{
	size_t size;

	for(size = 0;wave != NULL;wave = wave->next_ptr) {
		wave->recording_size = getUnitSize(wave);
		size += wave->recording_size;
	}
	return(size);
}

/***************************************************************************
 *	setEncodingSizes: ȷǡѴѥꥵꤹ
 *	
 *		size_t setEncodingSizes(WaveOrder *wave, 
 *								size_t (*getUnitSize)(WaveOrder *wave));
 *	
 *		WaveOrder *wave;	ȷǡ
 *		size_t (*getUnitSize)(WaveOrder *wave);
 *							ȷǡδñƼ掠ؿ
 *	֤
 *		ȷǡΥ
 *	
 *		WaveOrder Υ󥯥ȥꥹȷǡΥ롣
 ***************************************************************************/
size_t setEncodingSizes(WaveOrder *wave, 
						size_t (*getUnitSize)(WaveOrder *wave))
{
	size_t size;

	for(size = 0;wave != NULL;wave = wave->next_ptr) {
		wave->encoding_size = getUnitSize(wave);
		size += wave->encoding_size;
	}
	return(size);
}

/***************************************************************************
 *	NumOfList: ꥹȿ
 *	
 *		int NumOfList(const WavesLink *waves);
 *	
 *		const WavesLink *waves;
 *	֤
 *		ꥹȿ
 *	
 *	
 ***************************************************************************/
/*ARGSUSED*/
int NumOfList(const WavesLink *waves)
{
	int counter = 0;

	while(waves != NULL) {
		++counter, waves = waves->next_ptr;
	}
	return(counter);
}

/***************************************************************************
 *	NumberOfPanes: ꥹιֹ
 *	
 *		int NumberOfPanes(const WavesLink *waves);
 *	
 *		const WavesLink *waves;
 *	֤
 *		EOF		ȷ򤵤Ƥʤ
 *		ʾ塧	ꥹȿ
 *	
 *	
 ***************************************************************************/
/*ARGSUSED*/
int NumberOfPanes(const WavesLink *waves)
{
	int counter = 0;

	if(waves != NULL) {
		while(waves->prev_ptr != NULL) {
			++counter, waves = waves->prev_ptr;
		}
	} else {
		counter = EOF;
	}
	return(counter);
}

/***************************************************************************
 *	getMemoryList: ꡼ꥹѤʸ򤵤ݥ
 *	
 *		String *getMemoryList(WavesLink *waveOrder, int *numOfList);
 *	
 *		const WavesLink *waveOrder;	ȷꥹ
 *		int *numOfList;				ȷꥹȤο֤
 *	֤
 *		NULL		꡼­
 *		NULLʳ	ʸ򤵤ݥ
 *	
 *	
 ***************************************************************************/
/*ARGSUSED*/
String *getMemoryList(const WavesLink *waveOrder, int *numOfList)
{
	String *list_ptr, *toplist_ptr = NULL;
	const WavesLink *order;

	*numOfList = NumOfList(waveOrder);
	if(*numOfList > 0) {
		toplist_ptr = list_ptr = 
					(String*)malloc(sizeof(*list_ptr) * *numOfList);
		if(list_ptr != NULL) {
			for(order = waveOrder;order != NULL;
						order = order->next_ptr, ++list_ptr) {
				*list_ptr = order->wave_name;
			}
		}
	}
	return(toplist_ptr);
}

/***************************************************************************
 *	wave_search: 
 *	
 *		WaveSearch *wave_search(WaveOrder *wave, size_t offset);
 *	
 *		WaveOrder *wave;		ȷꥹ
 *		size_t offset;			ХåեƬΥեå
 *	֤
 *		NULL		꡼­
 *		NULLʳ	ʸ򤵤¤ΤΥݥ
 *	
 *		δؿ֤ͤϡؿǳݤƤΤǡ٤δؿ
 *		ԤͤѤäƤޤΤդ뤳ȡ
 *		̾ϡʲΤ褦˻Ѥ롣
 *		{
 *			WaveSearch *searching_ptr;
 *			
 *			searching_ptr = wave_search(wave, offset);
 *		}
 *		̤¸ϡʲΤ褦˵Ҥɤ
 *		{
 *			WaveSearch searching;
 *			
 *			searching = *wave_search(wave, offset);
 *		}
 ***************************************************************************/
/*ARGSUSED*/
WaveSearch *wave_search(WaveOrder *wave, size_t offset)
{
	WaveOrder *wave_ptr = wave;
	static WaveSearch searchingPoint;
	
	for(wave_ptr = wave;wave_ptr != NULL && offset > wave_ptr->wave_size;
								wave_ptr = wave_ptr->next_ptr) {
		offset -= wave_ptr->wave_size;
	}
	searchingPoint.wave_ptr = wave_ptr;
	searchingPoint.offset = offset;
	return((searchingPoint.wave_ptr != NULL)?(&searchingPoint):(NULL));
}

/***************************************************************************
 *	WaveGarbageCollection: ϿǤȤΡإ߽
 *	
 *		void WaveGarbageCollection(WaveOrder *wave);
 *	
 *		WaveOrder *wave;		ȷꥹ
 *	֤
 *		
 *	
 *		ϿǤȤȷѥǻѤƤʤʬ
 *		
 *		
 ***************************************************************************/
/*ARGSUSED*/
void WaveGarbageCollection(WaveOrder *wave)
{
	WaveOrder *waveSource;
	WaveOrder *waveDestination;
	WaveOrder *releasePoint;
	char *pcmWave;
	int pcmSize, sourcePoint, copySize, remainSize;
	
	while(wave != NULL) {
		if(wave->wave_size != unitSize || wave->recording_size != unitSize)
			break;
		wave = wave->next_ptr;
	}
	if(wave == NULL)
		return;				/* ߤʤ */
	if(wave->next_ptr == NULL && wave->wave_size == wave->recording_size)
		return;				/* ߤʤ */

	pcmWave = (char*)malloc(unitSize);
	pcmSize = 0;
	waveSource = wave;
	waveDestination = wave;
	while(waveSource != NULL) {
		if(waveSource->recording_size > unitSize) {
			fprintf(stderr, "*** %s(%d): Fatal Error!!!"
					"(You need Debug!!) ***\n", __FILE__, __LINE__);
		}
		remainSize = 0;
		copySize = waveSource->recording_size;
		if(copySize+pcmSize > unitSize) {
			copySize = unitSize - pcmSize;
			remainSize = waveSource->recording_size - copySize;
		}
		memcpy(pcmWave+pcmSize, waveSource->pcm_wave, copySize);
		if(remainSize > 0) {
			if(waveDestination->wave_size == unitSize) {
				memcpy(waveDestination->pcm_wave, pcmWave, unitSize);
			} else {
				free(waveDestination->pcm_wave);
				waveDestination->pcm_wave = pcmWave;
				pcmWave = (char*)malloc(unitSize);
			}
			memcpy(pcmWave, waveSource->pcm_wave, remainSize);
			pcmSize = remainSize;
			waveDestination->wave_size = unitSize;
			waveDestination->recording_size = unitSize;
			waveDestination = waveDestination->next_ptr;
		} else {
			pcmSize += copySize;
			if(pcmSize >= unitSize) {
				pcmSize = 0;
				waveDestination->wave_size = unitSize;
				waveDestination->recording_size = unitSize;
				waveDestination = waveDestination->next_ptr;
			}
		}
		waveSource = waveSource->next_ptr;
	}
	if(waveDestination->next_ptr != NULL) {
		releasePoint = waveDestination->next_ptr;
		releasePoint->prev_ptr = NULL;
		waveDestination->next_ptr = NULL;
	}
	free(waveDestination->pcm_wave);
	waveDestination->pcm_wave = (char*)malloc(pcmSize);
	if(waveDestination->pcm_wave != NULL) {
		memcpy(waveDestination->pcm_wave, pcmWave, pcmSize);
		waveDestination->wave_size = pcmSize;
		waveDestination->recording_size = pcmSize;
	}
	if(waveDestination->wave_size == 0 && waveDestination->next_ptr == NULL) {
		if(waveDestination->prev_ptr != NULL) {
			waveDestination->prev_ptr->next_ptr = NULL;
			free(waveDestination->pcm_wave);
			free(waveDestination);
		}
	}
	free(pcmWave);
}

/***************************************************************************
 *	getWave: ȷꥹȤ椫顢ꤵ줿֡Υǡ
 *	
 *		size_t getWave(unsigned char *buffer, WaveOrder *wave,
 *										size_t from, size_t size);
 *	
 *		unsigned char *buffer;	ȷǡ֤
 *		WaveOrder *wave;		ȷꥹ
 *		size_t from;			ȷ
 *		size_t size;			ȷ
 *	֤
 *		ԡХȿ
 *	
 *	
 ***************************************************************************/
/*ARGSUSED*/
size_t getWave(unsigned char *buffer, 
					WaveOrder *wave, size_t from, size_t size)
{
	Boolean workProcIsOver = True;
	size_t nbytes, remain_size = size;
	WaveOrder *wave_ptr = wave;
	WaveSearch searching;
	
	for(searching = *wave_search(wave, from), 
			nbytes = ((searching.wave_ptr != NULL)?
				(searching.wave_ptr->wave_size - searching.offset):(0));
			remain_size > 0 && searching.wave_ptr != NULL;
				remain_size -= nbytes, buffer += nbytes,
				searching.wave_ptr = searching.wave_ptr->next_ptr,
				searching.offset = 0, 
				nbytes = ((searching.wave_ptr != NULL)?
								(searching.wave_ptr->wave_size):(0))) {
		if(nbytes > remain_size)
			nbytes = remain_size;
		memcpy(buffer, 
				searching.wave_ptr->pcm_wave + searching.offset, nbytes);
	}
	return(size - remain_size);
}

#ifdef	OLD_IMPREMENT_BEFORE_GGXSND_0_8_0
size_t getWave(unsigned char *buffer, 
					WaveOrder *wave, size_t from, size_t size)
{
	Boolean workProcIsOver = True;
	size_t nbytes, remain_size = size;
	WaveOrder *wave_ptr = wave;
	WaveSearch searching;
	
	for(searching = *wave_search(wave, from), 
			nbytes = searching.wave_ptr->wave_size - searching.offset;
			remain_size > 0 && searching.wave_ptr != NULL;
			remain_size -= nbytes, buffer += nbytes,
			searching.wave_ptr = searching.wave_ptr->next_ptr,
			searching.offset = 0, nbytes = searching.wave_ptr->wave_size) {
		if(nbytes > remain_size)
			nbytes = remain_size;
		memcpy(buffer, 
				searching.wave_ptr->pcm_wave + searching.offset, nbytes);
	}
	return(size - remain_size);
}
#endif	/* OLD_IMPREMENT_BEFORE_GGXSND_0_8_0 */

/***************************************************************************
 *	setWave: ȷꥹȤλꤵ줿֡Υǡ񤭹ߤޤ
 *	
 *		size_t setWave(unsigned char *buffer, WaveOrder *wave,
 *										size_t from, size_t size);
 *	
 *		unsigned char *buffer;	ȷꥹȤο֤
 *		WaveOrder *wave;		ȷꥹ
 *		size_t from;			ȷ
 *		size_t size;			ȷ
 *	֤
 *		ԡХȿ
 *	
 *	
 ***************************************************************************/
/*ARGSUSED*/
size_t setWave(const unsigned char *buffer, 
					WaveOrder *wave, size_t from, size_t size)
{
	Boolean workProcIsOver = True;
	size_t nbytes, remain_size = size;
	WaveOrder *wave_ptr = wave;
	WaveSearch searching;
	
	for(searching = *wave_search(wave, from);
			remain_size > 0 && searching.wave_ptr != NULL;
			remain_size -= nbytes, buffer += nbytes,
			searching.wave_ptr = searching.wave_ptr->next_ptr,
			searching.offset = 0) {
		nbytes = searching.wave_ptr->wave_size - searching.offset;
		if(nbytes > remain_size)
			nbytes = remain_size;
		memcpy(searching.wave_ptr->pcm_wave + searching.offset, 
												buffer, nbytes);
	}
	return(size - remain_size);
}

#define pcmLevel(c)	(((c) & 0x80)?((c) & 0x7f):-(c))

/***************************************************************************
 *	getMinMax: Ѥλϰκ͡ǾͤĴ٤
 *	
 *		size_t getMinMax(int *min, int *max, 
 *							WaveOrder *wave, size_t from, size_t size);
 *	
 *		double *buffer;			
 *		WaveOrder *wave;		ȷꥹ
 *		size_t from;			ȷ
 *		size_t size;			ȷ
 *	֤
 *		ԡХȿ
 *	
 *	
 ***************************************************************************/
/*ARGSUSED*/
size_t getMinMax(int *min, int *max, 
					WaveOrder *wave, size_t from, size_t size)
{
	size_t nbytes;
	int remain_size = size;
	int counter, value, limit;
	unsigned char *value_ptr;
	WaveOrder *wave_ptr = wave;
	WaveSearch searching;
	
	for(searching = *wave_search(wave, from), 
			*min = *max = 
				pcmLevel(*(searching.wave_ptr->pcm_wave + searching.offset));
			remain_size > 0 && searching.wave_ptr != NULL;
			remain_size -= nbytes,
			searching.wave_ptr = searching.wave_ptr->next_ptr,
			searching.offset = 0) {
		nbytes = searching.wave_ptr->wave_size - searching.offset;
		if(nbytes > remain_size) {
			nbytes = remain_size;
			limit = nbytes + searching.offset;
		} else {
			limit = searching.wave_ptr->wave_size;
		}
		for(value_ptr = searching.wave_ptr->pcm_wave + searching.offset,
				counter = searching.offset;
				counter < limit;
				++counter, ++value_ptr) {
			value = pcmLevel(*value_ptr);
			if(value > *max)
				*max = value;
			if(value < *min)
				*min = value;
		}
	}
	return(size - remain_size);
}

/***************************************************************************
 *	wave_point: åΣغɸǡɸϤѴ
 *	
 *		static int wave_point(double x, const XawRepaintWave *waveInfo);
 *	
 *		double x;
 *		const XawRepaintWave *waveInfo;
 *	֤
 *		ǡɸϤ
 ***************************************************************************/
static int wave_point(double x, const XawRepaintWave *waveInfo)
{
	int result;
	
	result = waveInfo->size * (waveInfo->graphWidth * x / waveInfo->virtualWidth 
		+ waveInfo->graphBegin - waveInfo->dataBegin) / waveInfo->dataWidth;
	return(result);
}

#define isInner(x, min, max)	((x)>=(min) && (x)<(max))

/***************************************************************************
 *	graphRedraw: 
 *	
 *		void graphRedraw(Widget w, 
 *						XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 ***************************************************************************/
void graphRedraw(Widget w, XtPointer client_data, XtPointer call_data)
{
	int counter;
	int spoint, epoint;
	int start_point, end_point;
	int min, max;
	size_t size;
	double *buffer_ptr;
	WaveSearch searching = {NULL, 0};
	XawRepaintWave *waveInfo = call_data;

#ifdef	DEBUG
	printf("Width %d, (%d bytes.) / %d -- %d / %d -- %d.\n", 
			waveInfo->width, waveInfo->size, waveInfo->graphBegin,
			waveInfo->graphWidth, waveInfo->dataBegin, waveInfo->dataWidth);
#endif	/*DEBUG*/
	
	if(currentWaves != NULL) {
		size = sizeOfWave(currentWaves->wave, getEncodingSizeUnit);
		waveInfo->size = waveInfo->virtualWidth * 4;
		waveInfo->graphBegin = 0;
		waveInfo->graphWidth = waveInfo->virtualWidth * 4; 
		waveInfo->dataBegin = 0; 
		waveInfo->dataWidth = waveInfo->virtualWidth * 4;
		waveInfo->graphBegin = 0;
		waveInfo->size = size;
		waveInfo->graphBegin = waveInfo->dataBegin = 0; 
		waveInfo->graphWidth = waveInfo->dataWidth = size;
		buffer_ptr = waveInfo->wave;
		for(start_point = wave_point(0, waveInfo), counter = 1;
				counter <= waveInfo->virtualWidth;
				start_point = end_point, ++counter, buffer_ptr += 4) {
			end_point = wave_point(counter, waveInfo);
			if(isInner(start_point, 0, waveInfo->size) || 
					isInner(end_point, 0, waveInfo->size)) {
				spoint = (isInner(start_point, 0, waveInfo->size)?
									(start_point):(0));
				epoint = (isInner(end_point, 0, waveInfo->size)?
									(end_point):(waveInfo->size));
				searching = *wave_search(currentWaves->wave, spoint);
				getMinMax(&min, &max, currentWaves->wave, spoint, epoint - spoint);
				*buffer_ptr = pcmLevel(*(searching.wave_ptr->pcm_wave + 
										searching.offset)) / 127.0;
				*(buffer_ptr + 1) = (double)min/127.0;
				*(buffer_ptr + 2) = (double)max/127.0;
				searching = *wave_search(currentWaves->wave, epoint);
				*(buffer_ptr + 3) = pcmLevel(*(searching.wave_ptr->pcm_wave + 
										searching.offset)) / 127.0;
#ifdef	DEBUGS
				printf("%d (%d): %f -- %f Min %f Max %f\n", spoint, epoint - spoint, 
								*buffer_ptr, *(buffer_ptr + 3), 
								*(buffer_ptr + 1), *(buffer_ptr + 2));
#endif	/*DEBUGS*/
			}
		}
		waveInfo->size = waveInfo->virtualWidth * 4;
		waveInfo->graphBegin = waveInfo->dataBegin = 0; 
		waveInfo->graphWidth = waveInfo->dataWidth = size;
	} else {
		waveInfo->size = 0;
		waveInfo->graphBegin = 0;
		waveInfo->graphWidth = 0; 
		waveInfo->dataBegin = 0; 
		waveInfo->dataWidth = 0;
	}
#ifdef	DEBUG
	printf("Width %d, (%d bytes.) / %d -- %d / %d -- %d.\n", 
			waveInfo->virtualWidth, waveInfo->size, waveInfo->graphBegin,
			waveInfo->graphWidth, waveInfo->dataBegin, waveInfo->dataWidth);
#endif	/*DEBUG*/
}

/***************************************************************************
 *	getGraph: 
 *	
 *		size_t getGraph(unsigned char *buffer, WaveOrder *wave,
 *										size_t from, size_t size);
 *	
 *		double *buffer;			
 *		WaveOrder *wave;		ȷꥹ
 *		size_t from;			ȷ
 *		size_t size;			ȷ
 *	֤
 *		ԡХȿ
 *	
 *	
 ***************************************************************************/
/*ARGSUSED*/
size_t getGraph(double *buffer, WaveOrder *wave, size_t from, size_t size)
{
	size_t nbytes, remain_size = size;
	int counter;
	unsigned char *value_ptr;
	WaveOrder *wave_ptr = wave;
	WaveSearch searching;
	
	for(searching = *wave_search(wave, from), 
			nbytes = searching.wave_ptr->wave_size - searching.offset;
			remain_size > 0 && searching.wave_ptr != NULL;
			remain_size -= nbytes,
			searching.wave_ptr = searching.wave_ptr->next_ptr,
			nbytes = searching.wave_ptr->wave_size, searching.offset = 0) {
#ifdef	SELECTION_DEBUG
		printf("Value %d.\n", pcmLevel(*((searching.wave_ptr)->pcm_wave)));
#endif	/*SELECTION_DEBUG*/
		if(nbytes > remain_size)
			nbytes = remain_size;
		for(value_ptr = searching.wave_ptr->pcm_wave + searching.offset,
				counter = searching.offset;
				counter < searching.wave_ptr->wave_size;
				++counter, ++buffer, ++value_ptr) {
			*buffer = (double)pcmLevel(*value_ptr) / 127.0;
			/*printf("%f\n", *buffer);*/
		}
	}
	return(size - remain_size);
}

/***************************************************************************
 *	SetCurrentWaveName: ȷ̾Τꤹ
 *	
 *		void SetCurrentWaveName(WavesLink *wave);
 *	
 *		WavesLink *wave;		ȷꥹ
 *	֤
 *		ʤ
 *	
 *		ȷ̾ΤϿޤ
 *		
 ***************************************************************************/
void SetCurrentWaveName(WavesLink *wave)
{
	static char *untitle = "Untitled...";
	extern Widget pcmTitle;

	if(wave != NULL) {
		XtVaSetValues(pcmTitle, XtNlabel, (XtPointer)wave->wave_name, NULL);
	} else {
		XtVaSetValues(pcmTitle, XtNlabel, (XtPointer)untitle, NULL);
	}
}

/***************************************************************************
 *	WaveGraph: ȷ褹
 *	
 *		void WaveGraph(WavesLink *wave);
 *	
 *		WavesLink *wave;		ȷꥹ
 *	֤
 *		ʤ
 *	
 *		ȷơȷ׵᤹롣ȷ̾ΤϿޤ
 *		
 ***************************************************************************/
void WaveGraph(WavesLink *wave)
{
	extern Widget pcmWave;

	currentWaves = wave;
	SetCurrentWaveName(wave);
	if(wave != NULL) {
		WaveRedrawCall(pcmWave);
		XawWaveSelectionInit(pcmWave);
	}
}

/***************************************************************************
 *	WaveConvert: WaveChart åȤ selectConvert Хå
 *	
 *		void WaveConvert(Widget w, 
 *						XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	
 *		WaveChart åȤȷˤȤʤȷǡѴԤ
 *		Хåؿ
 ***************************************************************************/
void WaveConvert(Widget w, XtPointer client_data, XtPointer call_data)
{
	int start_point, end_point;
	size_t size;
	int copySize;
	XawWaveSelectionConvert *selectInfo = 
							(XawWaveSelectionConvert*)call_data;

#ifdef	SELECTION_DEBUG
	printf("%s(%d): WaveConvert()--start.\n", __FILE__, __LINE__);
#endif	/*SELECTION_DEBUG*/
	if(currentWaves != NULL) {
#ifdef	GGXSND_0_8_0_BUG
		WaveMemoryAlloc(size);
#endif	/* GGXSND_0_8_0_BUG */
		size = sizeOfWave(currentWaves->wave, getEncodingSizeUnit);
		start_point = 
			((selectInfo->selectStart < 0)?(0):(selectInfo->selectStart));
		end_point = 
			((selectInfo->selectEnd > size)?(size):(selectInfo->selectEnd));
		copySize = end_point - start_point;
		*(selectInfo->value_return) = (XtPointer)XtMalloc(copySize);
		*(selectInfo->length_return) = 
			getWave((unsigned char*)*(selectInfo->value_return), 
						currentWaves->wave, start_point, copySize);
		*(selectInfo->format_return) = 8;
		selectInfo->status = TRUE;
#ifdef	SELECTION_DEBUG
		printf("Selection Area[%d--%d]: selection size %d : buffer %p\n", 
				start_point, end_point, 
				*(selectInfo->length_return), *(selectInfo->value_return));
#endif	/*SELECTION_DEBUG*/
	}
#ifdef	SELECTION_DEBUG
	printf("%s(%d): WaveConvert()--end.\n", __FILE__, __LINE__);
#endif	/*SELECTION_DEBUG*/
}

#ifdef	EXPERIMENT_IMPLEMENT
#endif	/*EXPERIMENT_IMPLEMENT*/
#define LowerValue(x1, x2)	(((x1) < (x2))?(x1):(x2))

/***************************************************************************
 *	DeleteWave: ȷ󥯤椫ꤵ줿Хȿ
 *	
 *		static WaveOrder *DeleteWave(WaveOrder *wave, 
 *												size_t from, size_t size);
 *	
 *		WaveOrder *wave;
 *		size_t from;
 *		size_t size;
 *	֤
 *		Ϥ줿ȷ󥯤Ƭ
 *	
 *		
 *		
 ***************************************************************************/
static WaveOrder *DeleteWave(WaveOrder *wave, size_t from, size_t size)
{
	size_t nbytes, nbytes1, nbytes2;
	WaveOrder *waveEnd;
	WaveSearch deleteStart, deleteEnd, *searching_ptr;
	static WaveSearch nothing = {NULL, 0};

	deleteStart = (((searching_ptr = wave_search(wave, from)) != NULL)?
											(*searching_ptr):(nothing));
	deleteEnd   = (((searching_ptr = wave_search(wave, from+size)) != NULL)?
											(*searching_ptr):(nothing));
	while(wave != NULL && deleteEnd.wave_ptr != NULL) {
		nbytes1 = deleteStart.wave_ptr->wave_size - deleteStart.offset;
  		nbytes2 = deleteEnd.wave_ptr->wave_size - deleteEnd.offset;
  		nbytes = LowerValue(nbytes1, nbytes2);
  		if(nbytes > 0) {
			memmove(deleteStart.wave_ptr->pcm_wave + deleteStart.offset, 
				deleteEnd.wave_ptr->pcm_wave + deleteEnd.offset, nbytes);
		}
		deleteStart.offset += nbytes;
		while(deleteStart.offset >= deleteStart.wave_ptr->wave_size) {
			deleteStart.offset -= deleteStart.wave_ptr->wave_size;
			deleteStart.wave_ptr = deleteStart.wave_ptr->next_ptr;
		}
		deleteEnd.offset += nbytes;
		while((deleteEnd.wave_ptr != NULL)?
				(deleteEnd.offset >= deleteEnd.wave_ptr->wave_size):(0)) {
			deleteEnd.offset -= deleteEnd.wave_ptr->wave_size;
			deleteEnd.wave_ptr = deleteEnd.wave_ptr->next_ptr;
		}
	}
	if(deleteStart.wave_ptr != NULL) {
		deleteStart.wave_ptr->wave_size = deleteStart.offset;
		waveEnd = WaveUnitAlloc(deleteStart.wave_ptr->wave_size);
		if(waveEnd != NULL) {
			memcpy(waveEnd->pcm_wave, deleteStart.wave_ptr->pcm_wave, 
										deleteStart.wave_ptr->wave_size);
			if(deleteStart.wave_ptr->prev_ptr != NULL) {
				deleteStart.wave_ptr->prev_ptr->next_ptr = waveEnd;
			}
			if(deleteStart.wave_ptr == wave) {
				wave = waveEnd;
			}
			waveEnd->prev_ptr = deleteStart.wave_ptr->prev_ptr;
			waveEnd->encoding_size = waveEnd->wave_size;
			waveEnd->recording_size = waveEnd->wave_size;
		} else {
			wave = NULL;
		}
		deleteStart.wave_ptr->prev_ptr = NULL;
		releaseWaveMemory(deleteStart.wave_ptr);
	}
	return(wave);
}

#ifdef	EXPERIMENT_IMPLEMENT
#endif	/*EXPERIMENT_IMPLEMENT*/
/***************************************************************************
 *	WavePaste: WaveChart åȤ selectPaste Хå
 *	
 *		void WavePaste(Widget w, 
 *						XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	
 *		WaveChart åȤȷˤȤʤȷǡѴԤ
 *		Хåؿ
 ***************************************************************************/
void WavePaste(Widget w, XtPointer client_data, XtPointer call_data)
{
	int start_point, end_point;
	size_t size;
	int pastePos, pasteSize;
	int postWavePos;
	int reconnectType;
	WaveOrder *wavePrev, **waveMyself;
	WaveOrder *waveEnd, *wavePaste, *reconnectWave = NULL;
	WaveSearch searching, *searching_ptr;
	WaveSearch reconnectPos;
	XawWaveSelectionPaste *selectInfo = 
							(XawWaveSelectionPaste*)call_data;
	extern Widget pcmTitle;

#ifdef	SELECTION_DEBUG
	selectInfo->length /= unitSize;
	selectInfo->length *= unitSize;
	printf("%s(%d): WavePaste()--start.\n", __FILE__, __LINE__);
	printf("Paste: selection size %d : buffer %p : pastePos = %d\n", 
				selectInfo->length, selectInfo->value, selectInfo->pastePos);
#endif	/*SELECTION_DEBUG*/
	if(currentWaves != NULL) {
#ifdef	SELECTION_DEBUG
		printf("Paste: Original Wave Size %d [bytes] -- Encoding  "
					"Paste size %d [bytes]  Total %d [bytes]\n", 
					sizeOfWave(currentWaves->wave, getEncodingSizeUnit),
					selectInfo->length, selectInfo->length + 
					sizeOfWave(currentWaves->wave, getEncodingSizeUnit));
#endif	/*SELECTION_DEBUG*/
		/*******************************************************************
		 *	¦ȷȥڡȤȷ
		 *******************************************************************/
		size = sizeOfWave(currentWaves->wave, getEncodingSizeUnit);
		pastePos = selectInfo->pastePos;
		if(pastePos < 0)
			pastePos = 0;
		if(pastePos > size)
			pastePos = size;
		searching_ptr = wave_search(currentWaves->wave, pastePos);
#ifdef	SELECTION_DEBUG
		if(searching_ptr != NULL) {
			printf("Paste: searching_ptr: wave[Pointer %p, Offser %d]\n",
				searching_ptr->wave_ptr, searching_ptr->offset);
			if(searching_ptr->wave_ptr != NULL) {
				printf("\tencoding size %d [bytes] recording size %d [bytes]\n" 
					"\twave size %d [bytes] pcm_wave[Pointer %p], \n" 
					"\t<<prev_ptr %p, next_ptr %p>>\n",
					searching_ptr->wave_ptr->encoding_size,
					searching_ptr->wave_ptr->recording_size,
					searching_ptr->wave_ptr->wave_size,
					searching_ptr->wave_ptr->pcm_wave,
					searching_ptr->wave_ptr->prev_ptr,
					searching_ptr->wave_ptr->next_ptr);
			}
		}
#endif	/*SELECTION_DEBUG*/
		if(searching_ptr == NULL) {
			waveEnd = lastWaveOrder(currentWaves->wave);
			searching.wave_ptr = NULL;
			searching.offset = 0;
			wavePrev = waveEnd->prev_ptr;
			if(waveEnd->encoding_size < unitSize) {
				reconnectPos.wave_ptr = waveEnd;
				reconnectPos.offset   = waveEnd->encoding_size;
			} else {
				reconnectPos = searching;
			}
		} else {
			reconnectPos = searching = (*searching_ptr);
			wavePrev = searching.wave_ptr->prev_ptr;
		}
#ifdef	SELECTION_DEBUG
		printf("Wave size %d [bytes], %d [offset]\n", size, searching.offset);
#endif	/*SELECTION_DEBUG*/
		waveMyself = ((wavePrev != NULL)?
					(&wavePrev->next_ptr):(&currentWaves->wave));
		pasteSize = selectInfo->length + searching.offset;
		wavePaste = WaveMemoryAlloc(pasteSize);
		*waveMyself = wavePaste;
		wavePaste->prev_ptr = wavePrev;
		memcpy(wavePaste->pcm_wave, 
					reconnectPos.wave_ptr->pcm_wave, reconnectPos.offset);
		setWave((unsigned char*)selectInfo->value, 
					wavePaste, reconnectPos.offset, selectInfo->length);
		(void)setRecordingSizes(wavePaste, getMemorySizeUnit);
		(void)setEncodingSizes( wavePaste, getRecordingSizeUnit);
		/*******************************************************************
		 *	¦ȷȷ
		 *******************************************************************/
#ifdef	SELECTION_DEBUG
		printf("Paste: Wave Size %d [bytes] -- Encoding\n", 
				sizeOfWave(currentWaves->wave, getEncodingSizeUnit));
		printf("Paste: ^^^Test(pastePos + selectInfo->length) %d [bytes]\n", 
					pastePos + selectInfo->length);
#endif	/*SELECTION_DEBUG*/
		/*printf("¦ȷȷ\n");*/
		if(searching.wave_ptr != NULL) {
			/*printf("ȷ\n");*/
			waveEnd = lastWaveOrder(currentWaves->wave);
			waveMyself = ((waveEnd->prev_ptr != NULL)?
						(&waveEnd->prev_ptr->next_ptr):(&currentWaves->wave));
#ifdef	SELECTION_DEBUG
			printf("waveEnd->encoding_size %d, searching.offset %d.\n", 
							waveEnd->encoding_size, searching.offset);
#endif	/*SELECTION_DEBUG*/
			reconnectType = -(waveEnd->encoding_size < searching.offset) 
				+(waveEnd->encoding_size > searching.offset) 
				+(waveEnd->encoding_size == unitSize && searching.offset == 0);
			switch(reconnectType) {
			default:
#ifdef	SELECTION_DEBUG
				printf("WavePaste(): ۾ʾ֤Ǥ\n");
#endif	/*SELECTION_DEBUG*/
				break;
			case -1:	/* ˥ݤɬפʤ */
				printf("˥ݤɬפʤ\n");
				memcpy(searching.wave_ptr->pcm_wave, 
							waveEnd->pcm_wave, waveEnd->encoding_size);
				postWavePos = waveEnd->encoding_size;
				*waveMyself = searching.wave_ptr;
				searching.wave_ptr->prev_ptr = waveEnd->prev_ptr;
				waveEnd->prev_ptr = NULL;
				releaseWaveMemory(waveEnd);
				printf("Paste: Wave Size %d [bytes] -- Delete %d [bytes]\n", 
						sizeOfWave(currentWaves->wave, getEncodingSizeUnit)
						, searching.offset - postWavePos);
#ifdef	SELECTION_DEBUG
			printf("Paste: searching_ptr: wave[Pointer %p, Offser %d]\n",
				searching.wave_ptr, searching.offset);
			if(searching.wave_ptr != NULL) {
				printf("\tencoding size %d [bytes] recording size %d [bytes]\n" 
					"\twave size %d [bytes] pcm_wave[Pointer %p], \n" 
					"\t<<prev_ptr %p, next_ptr %p>>\n",
					searching.wave_ptr->encoding_size,
					searching.wave_ptr->recording_size,
					searching.wave_ptr->wave_size,
					searching.wave_ptr->pcm_wave,
					searching.wave_ptr->prev_ptr,
					searching.wave_ptr->next_ptr);
			}
#endif	/*SELECTION_DEBUG*/
				reconnectWave = DeleteWave(searching.wave_ptr, postWavePos, 
								searching.offset - postWavePos);
#ifdef	SELECTION_DEBUG
			printf("Paste: searching_ptr: wave[Pointer %p]\n",
				reconnectWave);
			if(reconnectWave != NULL) {
				printf("\tencoding size %d [bytes] recording size %d [bytes]\n" 
					"\twave size %d [bytes] pcm_wave[Pointer %p], \n" 
					"\t<<prev_ptr %p, next_ptr %p>>\n",
					reconnectWave->encoding_size,
					reconnectWave->recording_size,
					reconnectWave->wave_size,
					reconnectWave->pcm_wave,
					reconnectWave->prev_ptr,
					reconnectWave->next_ptr);
			}
#endif	/*SELECTION_DEBUG*/
				if((reconnectWave != NULL)?
							(reconnectWave->prev_ptr == NULL):(False)) {
					currentWaves->wave = reconnectWave;
#ifdef	SELECTION_DEBUG
					printf("WavePaste(): ȷƬѹޤ\n");
#endif	/*SELECTION_DEBUG*/
				}
				(void)setRecordingSizes(reconnectWave, getMemorySizeUnit);
				(void)setEncodingSizes( reconnectWave, getRecordingSizeUnit);
				break;
			case 0:		/* ꥵפ */
#ifdef	SELECTION_DEBUG
				printf("ꥵפ\n");
#endif	/*SELECTION_DEBUG*/
				memcpy(searching.wave_ptr->pcm_wave, 
							waveEnd->pcm_wave, waveEnd->encoding_size);
				/* to be continued... */
			case 2:
#ifdef	SELECTION_DEBUG
				if(reconnectType == 2)
					printf("Τޤ³\n");
#endif	/*SELECTION_DEBUG*/
				*waveMyself = searching.wave_ptr;
				searching.wave_ptr->prev_ptr = waveEnd->prev_ptr;
				waveEnd->prev_ptr = NULL;
				releaseWaveMemory(waveEnd);
				break;
			case 1:		/* ˥ݤɬפ */
#ifdef	SELECTION_DEBUG
				printf("˥ݤɬפ\n");
#endif	/*SELECTION_DEBUG*/
				searching.wave_ptr->prev_ptr = WaveUnitAlloc(unitSize);
				memcpy(searching.wave_ptr->prev_ptr->pcm_wave, 
							waveEnd->pcm_wave, waveEnd->encoding_size);
				postWavePos = waveEnd->encoding_size;
				searching.wave_ptr->prev_ptr->next_ptr = searching.wave_ptr;
				*waveMyself = searching.wave_ptr->prev_ptr;
				searching.wave_ptr->prev_ptr->prev_ptr = waveEnd->prev_ptr;
				waveEnd->prev_ptr = NULL;
				releaseWaveMemory(waveEnd);
				reconnectWave = 
					DeleteWave(searching.wave_ptr->prev_ptr, postWavePos, 
								searching.offset + unitSize - postWavePos);
				if((reconnectWave != NULL)?
							(reconnectWave->prev_ptr == NULL):(False)) {
					currentWaves->wave = reconnectWave;
				}
				(void)setRecordingSizes(reconnectWave, getMemorySizeUnit);
				(void)setEncodingSizes( reconnectWave, getRecordingSizeUnit);
				break;
			}
		}
		WaveRename(currentWaves);
		SetCurrentWaveName(currentWaves);
		makeMemoryList();
	} else {
		currentWaves = LinkedWaveAlloc(selectInfo->length);
		if(currentWaves != NULL) {
			setWave((unsigned char*)selectInfo->value, 
						currentWaves->wave, 0, selectInfo->length);
			(void)setRecordingSizes(currentWaves->wave, getMemorySizeUnit);
			(void)setEncodingSizes(currentWaves->wave, getRecordingSizeUnit);
			WaveRename(currentWaves);
			SetCurrentWaveName(currentWaves);
			makeMemoryList();
		}
	}
#ifdef	SELECTION_DEBUG
	printf("Paste: Wave Size %d [bytes] -- Encoding\n", 
				sizeOfWave(currentWaves->wave, getEncodingSizeUnit));
	printf("%s(%d): WavePaste()--end.\n", __FILE__, __LINE__);
#endif	/*SELECTION_DEBUG*/
}

/***************************************************************************
 *	WaveCut: WaveChart åȤ selectCut Хå
 *	
 *		void WaveCut(Widget w, 
 *						XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	
 *		WaveChart åȤȷˤȤʤȷǡѴԤ
 *		Хåؿ
 ***************************************************************************/
void WaveCut(Widget w, XtPointer client_data, XtPointer call_data)
{
	char waveName[9];
	size_t size;
	struct snd_head newHeader;
	WaveOrder *reconnectWave = NULL;
	XawWaveSelectionArea *cutInfo = (XawWaveSelectionArea*)call_data;
	extern Widget pcmWave;
	extern Widget pcmTitle;
	extern WavesLink *memoryListTop;

	if(currentWaves != NULL) {
		/*******************************************************************
		 *	
		 *******************************************************************/
		size = sizeOfWave(currentWaves->wave, getEncodingSizeUnit);
#ifdef	SELECTION_DEBUG
		printf("Cut: Original Wave Size %d [bytes] -- Encoding  --> ", size);
#endif	/*SELECTION_DEBUG*/
		if(cutInfo->selectStart < 0)
			cutInfo->selectStart = 0;
		if(cutInfo->selectEnd > size)
			cutInfo->selectEnd = size;
		reconnectWave = DeleteWave(currentWaves->wave, cutInfo->selectStart, 
								cutInfo->selectEnd - cutInfo->selectStart);
		if((reconnectWave!=NULL)?(reconnectWave->prev_ptr==NULL):(True))
			currentWaves->wave = reconnectWave;
		size = sizeOfWave(currentWaves->wave, getEncodingSizeUnit);
#ifdef	SELECTION_DEBUG
		printf("Cut: New Wave Size %d [bytes]\n", size);
#endif	/*SELECTION_DEBUG*/
		if(size == 0) {
			if(currentWaves->prev_ptr == NULL) {
				/* 󥯤Ƭ */
				memoryListTop = currentWaves->next_ptr;
			}
			UnlinkWaves(currentWaves);
			FreeWaves(currentWaves);
			currentWaves = NULL;
			XawWaveAllClear(pcmWave);
		} else {
			sprintf(waveName, "%.8s", currentWaves->header.name);
			make_sndHeader(waveName, size, &newHeader);
			memcpy(&currentWaves->header, &newHeader, sizeof(newHeader));
		}
		WaveRename(currentWaves);
		SetCurrentWaveName(currentWaves);
		makeMemoryList();
	}
}

/***************************************************************************
 *	waveClearCall: WaveChart åȤ select-cut ƽФ
 *	
 *		void waveClearCall(Widget w, 
 *						XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	
 *		
 ***************************************************************************/
void waveClearCall(Widget w, XtPointer client_data, XtPointer call_data)
{
	extern Widget pcmWave;

	XtCallActionProc(pcmWave, "select-clear", NULL, NULL, 0);
}

/***************************************************************************
 *	waveCutCall: 
 *	
 *		void waveCutCall(Widget w, 
 *						XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	
 *		
 ***************************************************************************/
void waveCutCall(Widget w, XtPointer client_data, XtPointer call_data)
{
	extern Widget pcmWave;

#ifdef	SELECTION_DEBUG
	printf("Copy Menu: Cut!!\n");fflush(stdout);
#endif	/*SELECTION_DEBUG*/
	XtCallActionProc(pcmWave, "select-cut", NULL, NULL, 0);
	OnceAction_ptr = SelectCopyOnce;
}

/***************************************************************************
 *	waveCopyCall: 
 *	
 *		void waveCopyCall(Widget w, 
 *						XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	
 *		
 ***************************************************************************/
void waveCopyCall(Widget w, XtPointer client_data, XtPointer call_data)
{
#ifdef	SELECTION_DEBUG
	printf("Copy Menu: Copy!!\n");fflush(stdout);
#endif	/*SELECTION_DEBUG*/
	
	OnceAction_ptr = SelectCopyOnce;
}

/***************************************************************************
 *	wavePasteCall: 
 *	
 *		void wavePasteCall(Widget w, 
 *						XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	
 *		
 ***************************************************************************/
void wavePasteCall(Widget w, XtPointer client_data, XtPointer call_data)
{
#ifdef	SELECTION_DEBUG
	printf("Copy Menu: Paste!!\n");fflush(stdout);
#endif	/*SELECTION_DEBUG*/

	OnceAction_ptr = SelectPasteOnce;
}

/***************************************************************************
 *	waveUnselectCall: 
 *	
 *		void waveUnselectCall(Widget w, 
 *						XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	
 *		
 ***************************************************************************/
void waveUnselectCall(Widget w, XtPointer client_data, XtPointer call_data)
{
#ifdef	SELECTION_DEBUG
	printf("Copy Menu: Unselect!!\n");fflush(stdout);
#endif	/*SELECTION_DEBUG*/

	OnceAction_ptr = SelectUnselectOnce;
}

/***************************************************************************
 *	OnceActionCall: ꤵ줿Ʊδؿ򣱲󡢸Ƥ
 *	
 *		void OnceActionCall(Widget w, XEvent *event, 
 *								String *params, Cardinal *num_params);
 *	
 *		Widget w;				å
 *		XEvent *event;			٥
 *		String *params;			ؤΰȤѴơ֥˵
 *								줿ʸ
 *		Cardinal *num_params;	params ʸ
 *	֤
 *		ʤ
 *	
 *		⥸塼⥰ХѿȤƻꤵ줿ؿؤΥݥ󥿤
 *		ơƱδؿƤ֡
 *		
 ***************************************************************************/
/* ARGSUSED */
void OnceActionCall(Widget w, XEvent *event, 
							String *params, Cardinal *num_params)
{
	if(OnceAction_ptr != NULL) {
		(*OnceAction_ptr)(w, event, params, num_params);
	}
	OnceAction_ptr = NULL;
}

/***************************************************************************
 *	SelectCopyOnce: 
 *	
 *		void SelectCopyOnce(Widget w, XEvent *event, 
 *								String *params, Cardinal *num_params);
 *	
 *		Widget w;				å
 *		XEvent *event;			٥
 *		String *params;			̤
 *		Cardinal *num_params;	̤
 *	֤
 *		ʤ
 *	
 *		
 *		
 ***************************************************************************/
/* ARGSUSED */
void SelectCopyOnce(Widget w, XEvent *event, 
							String *params, Cardinal *num_params)
{
	extern struct menuData copyMenus;

#ifdef	SELECTION_DEBUG
	printf("%s(%d): SelectCopyOnce()\n", __FILE__, __LINE__);fflush(stdout);
#endif	/*SELECTION_DEBUG*/
	XtGetSelectionValue(copyMenus.menu, XA_PRIMARY, WaveAtom, 
						requestor_callback, event, event->xbutton.time);
#ifdef	SELECTION_DEBUG
	printf("%s(%d): SelectCopyOnce()\n", __FILE__, __LINE__);fflush(stdout);
#endif	/*SELECTION_DEBUG*/
	if(XtOwnSelection(copyMenus.menu, XA_PRIMARY, event->xbutton.time, 
						convert_proc, NULL, NULL) == False) {
#ifdef	SELECTION_DEBUG
		printf("%s(%d): SelectCopyOnce()\n", __FILE__, __LINE__);fflush(stdout);
#endif	/*SELECTION_DEBUG*/
		XtWarning("Copy Menu: failed attempting to become "
				"selection owner; make a new selection.\n");
#ifdef	SELECTION_DEBUG
		printf("%s(%d): SelectCopyOnce()\n", __FILE__, __LINE__);fflush(stdout);
#endif	/*SELECTION_DEBUG*/
	} else {
#ifdef	SELECTION_DEBUG
		printf("%s(%d): SelectCopyOnce()\n", __FILE__, __LINE__);fflush(stdout);
#endif	/*SELECTION_DEBUG*/
	}
#ifdef	SELECTION_DEBUG
	printf("%s(%d): SelectCopyOnce()\n", __FILE__, __LINE__);fflush(stdout);
#endif	/*SELECTION_DEBUG*/
}

/***************************************************************************
 *	SelectPasteOnce: 
 *	
 *		void SelectPasteOnce(Widget w, XEvent *event, 
 *								String *params, Cardinal *num_params);
 *	
 *		Widget w;				å
 *		XEvent *event;			٥
 *		String *params;			̤
 *		Cardinal *num_params;	̤
 *	֤
 *		ʤ
 *	
 *		
 *		
 ***************************************************************************/
/* ARGSUSED */
void SelectPasteOnce(Widget w, XEvent *event, 
							String *params, Cardinal *num_params)
{
	extern Widget pcmWave;
	extern struct menuData copyMenus;

	if(XtOwnSelection(copyMenus.menu, XA_PRIMARY, event->xbutton.time, 
						convert_proc, NULL, NULL) == False) {
#ifdef	SELECTION_DEBUG
		printf("%s(%d): SelectPasteOnce()\n", __FILE__, __LINE__);fflush(stdout);
#endif	/*SELECTION_DEBUG*/
		XtWarning("Copy Menu: failed attempting to become "
				"selection owner; make a new selection.\n");
#ifdef	SELECTION_DEBUG
		printf("%s(%d): SelectPasteOnce()\n", __FILE__, __LINE__);fflush(stdout);
#endif	/*SELECTION_DEBUG*/
	} else {
#ifdef	SELECTION_DEBUG
		printf("%s(%d): SelectPasteOnce()\n", __FILE__, __LINE__);fflush(stdout);
#endif	/*SELECTION_DEBUG*/
	}
	XtCallActionProc(pcmWave, "select-paste", event, params, *num_params);
}

/***************************************************************************
 *	SelectUnselectOnce: 
 *	
 *		void SelectUnselectOnce(Widget w, XEvent *event, 
 *								String *params, Cardinal *num_params);
 *	
 *		Widget w;				å
 *		XEvent *event;			٥
 *		String *params;			̤
 *		Cardinal *num_params;	̤
 *	֤
 *		ʤ
 *	
 *		
 *		
 ***************************************************************************/
/* ARGSUSED */
void SelectUnselectOnce(Widget w, XEvent *event, 
							String *params, Cardinal *num_params)
{
	extern Widget pcmWave;

	XtCallActionProc(pcmWave, "select-unselect", event, params, *num_params);
}

/***************************************************************************
 *	convert_proc: ׵ᤵ줿쥯ǡ֤ؿ
 *	
 *		static Boolean convert_proc(Widget w, Atom *selection, Atom *target,
 *						Atom *type_return, XtPointer *value_return, 
 *						unsigned long *length_return, int *format_return);
 *	
 *	
 *		Widget w;			쥯ͭƤ륦å
 *		Atom *selection;	׵ᤵ줿쥯̾Ǥ륢ȥ
 *		Atom *target;		쥯׵᤹ηꤷޤ
 *								
 *	
 *		Atom *type_return; 	쥯򥳥СȤͤΥץѥƥ
 *							֤ޤ
 *		XtPointer *value_return;	
 *							쥯򥳥СȤͤΥɥ쥹֤
 *							ޤ
 *		unsigned long *length_return;	
 *							value_return 줿ͤĹformat_return 
 *							˻ꤵ줿ñ̤֤ޤ
 *		int *format_return;	value_return äƤ length_return Ĥ
 *							ǤΤ줾礭ӥåñ̤ǻꤷޤ
 *							81632Τ줫ǤʤФʤޤ
 *							ξˤꡢإФɬפʾˤϡХ
 *							ȥåפԤޤ
 *	֤
 *		False		СȤ
 *		True		СȤ
 *	
 *		See. The Definitive Guides to the X Window System
 *			X Toolkit Intrinsics Reference Manual (Editd by David Flanagan)
 ***************************************************************************/
/* ARGSUSED */
static Boolean convert_proc(Widget w, Atom *selection, Atom *target,
				Atom *type_return, XtPointer *value_return, 
				unsigned long *length_return, int *format_return)
{
	XSelectionRequestEvent *req = XtGetSelectionRequest(w, 
			*selection, (XtRequestId) NULL);

	/* handle all required atoms, and the one that we use */
	if (*target == XA_TARGETS(XtDisplay(w))) {
		/* TARGETS handling copied from xclipboard.c */
		Atom* targetP;
		Atom* std_targets;
		unsigned long std_length;
		XmuConvertStandardSelection(w, req->time, selection, 
				target, type_return,
				(XtPointer*)&std_targets, 
				&std_length, format_return);
		*value_return = XtMalloc(sizeof(Atom)*(std_length + 1));
		targetP = *(Atom**)value_return;
		*length_return = std_length + 1;
		*targetP++ = WaveAtom;
		bcopy((char*)std_targets, (char*)targetP, sizeof(Atom)*std_length);
		XtFree((char*)std_targets);
		*type_return = XA_ATOM;
		*format_return = sizeof(Atom) * 8;
		return(True);
	}
	/* Xt already handles MULTIPLE, no branch necessary */ 
	else if (*target == WaveAtom) {
		if(*value_return = (XtPointer)XtMalloc(PasteInfo.length)) {
			*type_return = PasteInfo.type;
			memcpy(*value_return, PasteInfo.value, PasteInfo.length);
			*length_return = PasteInfo.length;
			*format_return = PasteInfo.format;
			return(True);
		} else {
			return(False);
		}
	}
	else { 
		if (XmuConvertStandardSelection(w, CurrentTime, selection, 
				target, type_return, value_return, 
				length_return, format_return))
				return True;
		else {
			XtWarning("waveChart: requestor is requesting"
					" unsupported selection target type.\n");
			return(False);
		}
	}
}

/***************************************************************************
 *	requestor_callback: ׵ᤵ줿쥯ǡλ˸ƤФ
 *	
 *		static void requestor_callback(Widget w, Atom *selection, Atom *target,
 *						Atom *type_return, XtPointer *value_return, 
 *						unsigned long *length_return, int *format_return);
 *	
 *	
 *		Widget w;				쥯ͤ׵ᤷåȤ
 *		XtPointer client_data;	쥯ͤ׵ᤷȤˤδؿȤ
 *								Ͽǡꤷޤ
 *		Atom *selection;		׵ᤷƤ륻쥯ꤷޤ
 *		Atom *type;		 		쥯ͤɽϤꤷޤ
 *		XtPointer value;		쥯ͤؤΥݥ󥿤ꤷޤ
 *		unsigned long *length;	ͤǿꤷޤ
 *		int *format;			ͤΥǡǤ礭ӥåñ̤ǻꤷ
 *								ޤ
 *	
 *		See. The Definitive Guides to the X Window System
 *			X Toolkit Intrinsics Reference Manual (Editd by David Flanagan)
 ***************************************************************************/
/* ARGSUSED */
static void requestor_callback(Widget w, XtPointer client_data, 
				Atom *selection, Atom *type, 
				XtPointer value, unsigned long *length, int *format)
{
#ifdef	SELECTION_DEBUG
	printf("%s(%d): requestor_callback()\n", __FILE__, __LINE__);fflush(stdout);
#endif	/*SELECTION_DEBUG*/
	if ((value == NULL) && (*length == 0)) {
		XBell(XtDisplay(w), 100);
		XtWarning("SelectionMenu: no selection or selection timed out;"
					" try again\n");
	} else {
#ifdef	SELECTION_DEBUG
		printf("%s(%d): requestor_callback()\n", __FILE__, __LINE__);fflush(stdout);
#endif	/*SELECTION_DEBUG*/
		PasteInfo.type = *type;
		PasteInfo.value = value;
		PasteInfo.length = *length;
		PasteInfo.format = *format;
#ifdef	SELECTION_DEBUG
		printf("%s(%d): requestor_callback()\n", __FILE__, __LINE__);fflush(stdout);
#endif	/*SELECTION_DEBUG*/
	}
#ifdef	SELECTION_DEBUG
	printf("%s(%d): requestor_callback()\n", __FILE__, __LINE__);fflush(stdout);
#endif	/*SELECTION_DEBUG*/
}

/***************************************************************************
 *	preSelectionMenu: 쥯󡦥˥塼ġԲɽ
 *	
 *		static void preSelectionMenu(Widget w, 
 *								XtPointer client_data, XtPointer garbage);
 *	
 *		Widget w;				å
 *		XtPointer client_data;	˥塼ֹ
 *		XtPointer garbage;		̤
 *	
 *		
 ***************************************************************************/
/* ARGSUSED */
void preSelectionMenu(Widget w, XtPointer client_data, XtPointer garbage)
{
	Boolean sensitive;
	extern Widget pcmWave;
	struct menuData *menuInfo = (struct menuData*) client_data;

	sensitive = XawIsWaveChartSelecting(pcmWave);

	XtSetSensitive((menuInfo->info+1)->myWidget, sensitive);
	XtSetSensitive((menuInfo->info+3)->myWidget, (PasteInfo.value != NULL));
	XtSetSensitive((menuInfo->info+5)->myWidget, sensitive);
	XtSetSensitive((menuInfo->info+6)->myWidget, sensitive);
	XtSetSensitive((menuInfo->info+8)->myWidget, sensitive);
}

